--[[
TCFT3
(c) By Plozi
Version 1.0.0

Based on the original TCFT made by Moda

** Changelog

]]

TCFT3.Connection = {}

-- Socket callback handlers
-- Connection
TCFT3.Connection.connect = function(sock,errmsg)
	if (sock) then
		TCFT3.Connection.PeerName = sock.tcp:GetPeerName()
		if (TCFT3.Connection.PeerName ~= nil) then
			TCFT3.Connection.isConnected = true
			TCFT3.Connection.isLoggedin = false
			TCFT3.Connection.Socket = sock.tcp
			TCFT3.Connection.Send = sock.Send
			TCFT3.SendData({ cmd="100", username=TCFT3.Settings.Data.username, password=TCFT3.Settings.Data.password, idstring=TCFT3.IdString })
		else 
			TCFT3.Connection.isLoggedin = false
			TCFT3.Connection.isConnected = false
			TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.RED .. "Connection to server failed.", true)
			if (errmsg) then
				TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.RED .. "Error: " .. errmsg)
			else
				TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.RED .. "Unknown error.")
			end
		end
	else
		TCFT3.Connection.isLoggedin = false
		TCFT3.Connection.isConnected = false
		TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.RED .. "Connection to server failed.", true)
		if (errmsg) then
			TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.RED .. "Error: " .. errmsg)
		else
			TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.RED .. "Unknown error.")
		end
	end
end

-- Server close the connection... or lines are down
TCFT3.Connection.disconnect = function()
	TCFT3.Connection.isConnected = false
	TCFT3.Connection.isLoggedin = false
	TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.RED.."Connection to server lost.", true)
	TCFT3.SetStatusLine(TCFT3.colors.RED .. "Not connected to server")
	TCFT3.connectButton.title = "Connect"
end

-- Receive data

TCFT3.Connection.getline = function(sock, line)
	line = string.gsub(line,"[\r\n]","")
	if (TCFT3.debug==1) then TCFT3.AddStatus(TCFT3.colors.YELLOW..'<<< ' .. line) end
	local data = json.decode(line)
	local cmd = tonumber(data.cmd)
	
	if (cmd>0) then
		local evtparams = data
		if (TCFT3.Events[cmd]) then
			if (TCFT3.debug==1) then TCFT3.AddStatus(TCFT3.colors.YELLOW .. "Received Event from server: " .. cmd) end
			TCFT3.Events[cmd](evtparams)
		else
			TCFT3.AddStatus(TCFT3.colors.RED .. 'Unknown Event from server: ' .. cmd)
		end
	else
		if Line ~= '' then
			local length = string.len(Line);
			TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.RED..'Invalid Event from server, '..length..' characters: >'..Line..'<')
		end
	end
end

-- Check connection - try connect if disconnected or disconnect if connected
TCFT3.Connection.CheckConnection = function()
	if (TCFT3.Connection.isConnected) then
		SetShipPurchaseColor(229)
		TCFT3.SendData({ cmd="101" })
		TCFT3.Connection.Socket:Disconnect()
		TCFT3.Connection.Socket = nil
		TCFT3.Connection.isConnected = false
		TCFT3.Connection.isLoggedin = false
		TCFT3.connectButton.title = "Connect"
		TCFT3.SetStatusLine(TCFT3.colors.RED .. "Not Connected to the server.")
		TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.RED .. "Connection to server closed.", true)
	else
		TCFT3.Connection.Socket = TCP.make_client(TCFT3.Server,27056,TCFT3.Connection.connect,TCFT3.Connection.getline,TCFT3.Connection.disconnect)
	end
end

-- Clean up the connection
TCFT3.Connection.CleanUp = function()
	if (TCFT3.Connection.isConnected) then
		TCFT3.SendData({ cmd="101" })
		TCFT3.Connection.Socket:Disconnect()
		TCFT3.Connection.isConnected = false
		TCFT3.Connection.isLoggedin = false
	end
end

