--[[
Guild bank functions
	Lisa added on line 33 the "Applicant" option to the member pull down.
	Seems to work fine if you have this added.  Without it, type shows as ? 
	In the Guild list.
]]

TCFT3.Guild = {}
TCFT3.Guild.MembersFirstUpdate = false

TCFT3.GuildBank = TCFT3.GuildBank or {}
TCFT3.GuildBankLog = TCFT3.GuildBankLog or {}
TCFT3.GuildBankLog.CurrentPage = TCFT3.GuildBankLog.CurrentPage or 1
TCFT3.GuildBankLog.UpdateIdx = 0
TCFT3.GuildBankLog.FirstUpdate = false 

TCFT3.GuildActivity = TCFT3.GuildActivity or {}
TCFT3.GuildActivity.CurrentPage = TCFT3.GuildActivity.CurrentPage or 1
TCFT3.GuildActivity.UpdateIdx = 0
TCFT3.GuildActivity.FirstUpdate = false

TCFT3.GuildMembers = TCFT3.GuildMembers or {} 

TCFT3.GuildBank.PageSize = 15

TCFT3.Guild.MemberRanks = {
	[0] = "Probie",
	[1] = "Member",
	[2] = "Lieutenant",
	[3] = "Council/Lt.",
	[4] = "Council",
	[5] = "Commander",
	[6] = "Applicant"
}

dofile("ui/ui_guild.lua")


TCFT3.GuildBank.UpdateActivity = function()
	TCFT3.GuildBank.Activity:clear()
	if (GetGuildTag()~="") then
		local page = (TCFT3.GuildActivity.CurrentPage * TCFT3.GuildBank.PageSize) - (TCFT3.GuildBank.PageSize - 1)
		TCFT3.GuildBank.ActivityPage.title = "Guild Activity Page " .. TCFT3.GuildActivity.CurrentPage
		TCFT3.GuildActivity.UpdateIdx = 1
		TCFT3.GuildBank.Activity.NUMLIN=2
		TCFT3.GuildBank.Activity:setcell(2, 2, "Updating, please wait...")
		Guild.getactivitylogpage(page)
	else
		TCFT3.GuildBank.Activity.NUMLIN=2
		TCFT3.GuildBank.Activity:setcell(2, 2, "You are not in a guild.")
	end
end

TCFT3.GuildBank.UpdateBankLog = function()
	TCFT3.GuildBank.Log:clear()
	if (GetGuildTag()~="") then
		local page = (TCFT3.GuildBankLog.CurrentPage * TCFT3.GuildBank.PageSize) - (TCFT3.GuildBank.PageSize - 1)
		TCFT3.GuildBank.LogPage.title = "Guild Bank Log Page " .. TCFT3.GuildBankLog.CurrentPage
		TCFT3.GuildBankLog.UpdateIdx = 1
		TCFT3.GuildBank.Log.NUMLIN=2
		TCFT3.GuildBank.Log:setcell(2, 2, "Updating, please wait...")
		Guild.getbanklogpage(page)
	else
		TCFT3.GuildBank.Log.NUMLIN=2
		TCFT3.GuildBank.Log:setcell(2, 2, "You are not in a guild.")
	end
end

TCFT3.GuildBank.DumpToLog = function()
	local cols = TCFT3.GuildBank.Log.NUMCOL - 1
	local rows = TCFT3.GuildBank.Log.NUMLIN
	
	for row = 0, rows do
		local line = ""
		if (TCFT3.GuildBank.LogDumpLinenumbers==true) then
			line = row .. "\t"
		end
		for col = 1, cols do
			line = line .. TCFT3.GuildBank.Log[row..":"..col].."\t" 
		end 
		console_print(line)
	end
end

--[[ Memberlist functions ]]
TCFT3.Guild.SaveMember = function(member)
	TCFT3.SendData({ cmd="1510", member=member })
end

TCFT3.Guild.CreateMember = function()
	TCFT3.EditMemberName.value = ""
	TCFT3.EditMemberJoin.value = "yyyy-mm-dd"
	TCFT3.EditMemberDialogTitle.title="Create new member"
	TCFT3.EditMemberRank.value = 1
	TCFT3.EditMemberDialog.saveid = -1
	PopupDialog(TCFT3.EditMemberDialog, iup.CENTER, iup.CENTER)
end

TCFT3.Guild.EditMember = function()
	local member = TCFT3.Guild.MemberList:selecteditem()
	if (member==nil) then
		TCFT3.MessageDialog("Edit Member", "Select a member in the list for editing.")
		return
	end
	local member = TCFT3.Guild.MemberList:selecteditem() or { id=-1, name="", rank="Probie" }
	if (tonumber(member.id) or -1>0) then
		local mrank = 1
		for idx=0, #TCFT3.Guild.MemberRanks do
			if (TCFT3.Guild.MemberRanks[idx]==member.rank) then
				mrank = idx+1
				break
			end
		end
		TCFT3.EditMemberRank.value = mrank
		TCFT3.EditMemberName.value = member.name or ""
		TCFT3.EditMemberJoin.value = (member.joindate~="0" and member.joindate) or "yyyy-mm-dd"
		TCFT3.EditMemberDialog.saveid = member.id
		TCFT3.EditMemberDialogTitle.title="Edit member"
		PopupDialog(TCFT3.EditMemberDialog, iup.CENTER, iup.CENTER)
	else
		TCFT3.ErrorDialog("Edit Member", "An error occured while trying to edit a member.")
	end
end

TCFT3.Guild.DeleteMember2 = function(id)
	id = tonumber(id) or 0
	TCFT3.SendData({ cmd="1520", memberid=id })
end

TCFT3.Guild.DeleteMember = function()
	local member = TCFT3.Guild.MemberList:selecteditem()
	if (member==nil) then
		TCFT3.MessageDialog("Delete Member", "Select a member in the list to delete.")
		return
	end
	local member = TCFT3.Guild.MemberList:selecteditem()
	if (member~=nil) then
		TCFT3.ConfirmDialog("Delete Member", "Delete member\n" .. TCFT3.colors.RED .. member.name .. TCFT3.colors.NORMAL .. "\nAre you sure?", "Yes", 
			function()
				TCFT3.Guild.DeleteMember2(member.id)
			end,
			"No",
			nil
		)	
	end	
end

TCFT3.Guild.UpdateGuildMembers = function()
	TCFT3.Guild.MemberList:clear()
	-- Fetch members from the server
	TCFT3.SendData({ cmd="1500" })
end

-- Events
TCFT3.GuildBank.EventActivityPage = function(_, params)
	local num = #params
	for i, log in ipairs(params) do
		local act = { date = os.date("%Y-%m-%d %H:%M", log.timestamp), activity=log.activity }
		TCFT3.GuildBank.Activity:additem(act)
	end
	TCFT3.GuildBank.ActivityPrevBtn.active = (TCFT3.GuildActivity.CurrentPage>1 and "YES") or "NO"
	TCFT3.GuildBank.ActivityFirstBtn.active = (TCFT3.GuildActivity.CurrentPage>1 and "YES") or "NO"
	TCFT3.GuildBank.ActivityNextBtn.active = (num>0 and "YES") or "NO"
	if (TCFT3.GuildActivity.UpdateIdx<TCFT3.GuildBank.PageSize) and (#params) then
		Guild.getactivitylogpage(((TCFT3.GuildActivity.CurrentPage * TCFT3.GuildBank.PageSize) - (TCFT3.GuildBank.PageSize - 1)) + TCFT3.GuildActivity.UpdateIdx)
	else
		 TCFT3.GuildBank.Activity:update()
	end
	TCFT3.GuildActivity.UpdateIdx = TCFT3.GuildActivity.UpdateIdx + 1
end

-- One page of bank log
TCFT3.GuildBank.EventBankLogPage = function(_, params)
	--[[
	current: 4239000000
	charname: "electric_sheep"
	previous: 4239002783
	timestamp: 1295207351
	description: "OCD"
	action: "withdrawal"
	]]
	-- console_print("Banklog page ")
	local num = #params
	for i, log in ipairs(params) do
		local amount = log.current - log.previous
		local deposit = (amount>-1 and amount) or 0
		local withdraw = (amount<0 and amount) or 0
		
		local act = { date = os.date("%Y-%m-%d %H:%M", log.timestamp), name=log.charname, desc=log.description, balance=log.current, withdraw=withdraw, deposit=deposit }
		if (amount<0) then
			act.cellfgcolors = {}
			act.cellfgcolors[3]="220 66 66"
		end
		TCFT3.GuildBank.Log:additem(act)
	end
	TCFT3.GuildBank.LogPrevBtn.active = (TCFT3.GuildBankLog.CurrentPage>1 and "YES") or "NO"
	TCFT3.GuildBank.LogFirstBtn.active = (TCFT3.GuildBankLog.CurrentPage>1 and "YES") or "NO"
	TCFT3.GuildBank.LogNextBtn.active = (num>0 and "YES") or "NO"
	
	if (TCFT3.GuildBankLog.UpdateIdx<TCFT3.GuildBank.PageSize) and (#params) then
		Guild.getbanklogpage(((TCFT3.GuildBankLog.CurrentPage * TCFT3.GuildBank.PageSize) - (TCFT3.GuildBank.PageSize - 1)) + TCFT3.GuildBankLog.UpdateIdx)
	else
		 TCFT3.GuildBank.Log:update()
	end
	TCFT3.GuildBankLog.UpdateIdx = TCFT3.GuildBankLog.UpdateIdx + 1
end

RegisterEvent(TCFT3.GuildBank.EventBankLogPage, "GUILD_BANK_LOG")
RegisterEvent(TCFT3.GuildBank.EventActivityPage, "GUILD_ACTIVITY_LOG") 
