--[[
TCFT3
(c) By TGFT Engineers 
** Changelog
2017-09-28 - added ircRelay function, fixed apostrophe in tc3 chat
2017-10-18 - bugfix for relay crashing the client
2020-01-18 - Added 'tct' command. ~Scion Spy
2020-02-01 - Added obfuscated alt finding code ~rio
2020-02-07 - Added auto distancing support -Xanos Carbonos
2020-03-01 - fixed auto membership pay bot
2020-04-21 - fixed pm to discord admin relay
2020-04-22 - fixed auto distancing bug -Xan
2020-05-22 - removed irc support due to bug

]]

TCFT3 = TCFT3 or {}
TCFT3.Version = "3.0.5"
TCFT3.ChatType = 1 -- Default to tc3 chat
TCFT3.LastPrivMsgUser = ""
TCFT3.Binds = {} -- Keyboard binds
TCFT3.IdString = "opeaOAzep329dnroa882l3kweuwhsendw83gbsyaa"
--TCFT3.IdString = "opxaOAzep319dnroa881l3kweuwhsdndw93gbsyaa"
TCFT3.ServerVersion = "0.0.0"
TCFT3.Server = "vo.aoczone.net"
TCFT3.debug = 0
TCFT3.StatusList = {} -- Table with status messages in main TCFT3 chat
TCFT3.GuildOnlineTimer = Timer()
TCFT3.PDASecInfo = nil
TCFT3.StationSecInfo = nil
TCFT3.CapshipSecInfo = nil
TCFT3.IsInitialised = false

TCFT3.SettingsSaveId = 81922705660

TCFT3.GuildMembers = {} -- Should contain GuildMembers[name] = rank - used to display users here and there...

TCFT3.UserOptions = {} -- Options from server for current logged in user

-- Have to define targetless somehow to be able to check it...
targetless = targetless or {}
targetless.api = targetless.api or {}
targetless.api.radarlock = targetless.api.radarlock or false
targetless.var = targetless.var or {}
targetless.var.scanlock = targetless.var.scanlock or false

-- Load sounds
gksound.GKLoadSound{soundname='TCFT3sound1',filename='plugins/TCFT3/sound/bipp01.ogg'}
gksound.GKLoadSound{soundname='TCFT3sound2',filename='plugins/TCFT3/sound/bipp02.ogg'}
gksound.GKLoadSound{soundname='TCFT3sound3',filename='plugins/TCFT3/sound/bipp03.ogg'}
gksound.GKLoadSound{soundname='TCFT3sound4',filename='plugins/TCFT3/sound/bipp04.ogg'}
gksound.GKLoadSound{soundname='TCFT3sound5',filename='plugins/TCFT3/sound/bipp05.ogg'}
gksound.GKLoadSound{soundname='TCFT3sound6',filename='plugins/TCFT3/sound/bipp01.ogg'}
gksound.GKLoadSound{soundname='TCFT3sound7',filename='plugins/TCFT3/sound/boing02.ogg'}
gksound.GKLoadSound{soundname='TCFT3sound8',filename='plugins/TCFT3/sound/boing03.ogg'}
gksound.GKLoadSound{soundname='TCFT3sound9',filename='plugins/TCFT3/sound/bipp01.ogg'}
gksound.GKLoadSound{soundname='TCFT3sound10',filename='plugins/TCFT3/sound/charge01.ogg'}
gksound.GKLoadSound{soundname='TCFT3sound11',filename='plugins/TCFT3/sound/dill01.ogg'}
gksound.GKLoadSound{soundname='TCFT3sound12',filename='plugins/TCFT3/sound/doorbell01.ogg'}
gksound.GKLoadSound{soundname='TCFT3sound13',filename='plugins/TCFT3/sound/oiik01.ogg'}
gksound.GKLoadSound{soundname='TCFT3sound14',filename='plugins/TCFT3/sound/tada01.ogg'}
gksound.GKLoadSound{soundname='TCFT3sound15',filename='plugins/TCFT3/sound/trideli01.ogg'}
gksound.GKLoadSound{soundname='TCFT3sound16',filename='plugins/TCFT3/sound/zapp01.ogg'}

TCFT3.Sounds = {}
TCFT3.Sounds['Click'] = 'click';
TCFT3.Sounds['Explosion'] = 'explosion';
TCFT3.Sounds['Gauss'] = 'gauss';
TCFT3.Sounds['Laser'] = 'laser';
TCFT3.Sounds['Mine'] = 'mine';
TCFT3.Sounds['Mouseover'] = 'mouseover';
TCFT3.Sounds['Powerup'] = 'powerup';
TCFT3.Sounds['Prox Warning'] = 'prox.warning';
TCFT3.Sounds['Zapp'] = 'bipp1';
TCFT3.Sounds['TCFT3 01'] = 'TCFT3sound1';
TCFT3.Sounds['TCFT3 02'] = 'TCFT3sound2';
TCFT3.Sounds['TCFT3 03'] = 'TCFT3sound3';
TCFT3.Sounds['TCFT3 04'] = 'TCFT3sound4';
TCFT3.Sounds['TCFT3 05'] = 'TCFT3sound5';
TCFT3.Sounds['TCFT3 06'] = 'TCFT3sound6';
TCFT3.Sounds['TCFT3 07'] = 'TCFT3sound7';
TCFT3.Sounds['TCFT3 08'] = 'TCFT3sound8';
TCFT3.Sounds['TCFT3 09'] = 'TCFT3sound9';
TCFT3.Sounds['TCFT3 10'] = 'TCFT3sound10';
TCFT3.Sounds['TCFT3 11'] = 'TCFT3sound11';
TCFT3.Sounds['TCFT3 12'] = 'TCFT3sound12';
TCFT3.Sounds['TCFT3 13'] = 'TCFT3sound13';
TCFT3.Sounds['TCFT3 14'] = 'TCFT3sound14';
TCFT3.Sounds['TCFT3 15'] = 'TCFT3sound15';
TCFT3.Sounds['TCFT3 16'] = 'TCFT3sound16';

TCFT3.SoundLabels = {}

for key, val in pairs(TCFT3.Sounds) do
	table.insert(TCFT3.SoundLabels, key)
end

table.sort(TCFT3.SoundLabels)
table.insert(TCFT3.SoundLabels, 1, "None")

-- Load other files
dofile("tcpsock.lua")
dofile("json.lua")
dofile("common.lua")
dofile("class/matrix.class.lua")
dofile("events.lua")
dofile("connection.lua")
dofile("trading.lua")
dofile("mining.lua")
dofile("help.lua")
dofile("cargolist.lua")
dofile("settings.lua")
dofile("inventory.lua")
dofile("guild.lua")
dofile("comdata.lua")
dofile("navigation.lua")
dofile("lastseen.lua")
dofile("players.lua")
dofile("ui/ui_main.lua")
dofile("relay/relay.lua")
dofile("tct.lua");

-- Selected tab
TCFT3.CurMainTab = TCFT3.TCFTTab

TCFT3.DebugPrint = function(msg)
	console_print(msg)
end

-- AutoAccept the aula
local eula_original_show = EULADialog.show_cb

function EULADialog:show_cb()
  eula_original_show(EULADialog)
  local old_eula = gkini.ReadString("Vendetta", "EULA", SHA1(GetEULA()))
  local new_eula = SHA1(GetEULA())
  if old_eula == new_eula then
    EULADialog[1][1][3][1][2][2].action() -- this is the "Accept" button
  end
  gkini.WriteString("Vendetta", "EULA", new_eula)
end

local function get_args(str)
	local quotechar
	local i=0
	local args,argn,rest={},1,{}
	while true do
		local found,nexti,arg = string.find(str, '^"(.-)"%s*', i+1)
		if not found then found,nexti,arg = string.find(str, "^'(.-)'%s*", i+1) end
		if not found then found,nexti,arg = string.find(str, "^(%S+)%s*", i+1) end
		if not found then break end
		table.insert(rest, string.sub(str, nexti+1))
		table.insert(args, arg)
		i = nexti
	end
	return args,rest
end


-- Main command - display TCFT3 window
TCFT3.Command = function(_, args)
	if (args) then
		local numargs = #args
		local cmd = string.lower(args[1])

		local subcommand = string.lower(args[2] or "")

		-- Asteriod Scanner commands
		if (cmd=="scanner") then
			if (subcommand=="on") then -- turn scanner on
				TCFT3.Mining.Scanner.Start()
			elseif (subcommand=="off") then -- turn scanner off
				TCFT3.Mining.Scanner.Stop()
			elseif (subcommand=="toggle") then -- toggle scanner on/off
				TCFT3.Mining.Scanner.Toggle()
			end
		elseif (cmd=="test") then
			-- table.insert(TCFT3.LastSeen.Notifications, { time=os.time(), txt="Testing Plozi", label=nil })
			for id, name in pairs(SystemNames) do
				console_print(id .. " - " .. name)
			end
		elseif (cmd=="cargolist") then
			if (not PlayerInStation()) then
				TCFT3.DisplayCargolist()
			end
		elseif (cmd=="autoeject") then
			if (subcommand=="on") then -- turn autoeject on
				TCFT3.Settings.Data.AutoEjectActive = "ON"
			elseif (subcommand=="off") then -- turn autoeject off
				TCFT3.Settings.Data.AutoEjectActive = "OFF"
			elseif (subcommand=="toggle") then -- toggle autoeject mode
				TCFT3.Settings.Data.AutoEjectActive = (TCFT3.Settings.Data.AutoEjectActive=="ON" and "OFF") or "ON"
			end
			TCFT3.AutoEjectActive.value = TCFT3.Settings.Data.AutoEjectActive
			TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.NORMAL .. "AutoEject turned " .. TCFT3.Settings.Data.AutoEjectActive, true)
		elseif (cmd=="navedit") then
			TCFT3.PloziNav.Editor.ShowEditor()
		elseif (cmd=="navreload") then
			TCFT3.PloziNav.LoadServerNavData()
		elseif (cmd=="connect") then
			TCFT3.Connection.CheckConnection()
		elseif (cmd=="lastseen") then
			local name = ""
			for i=2,numargs do name = name .. " " .. (args[i] or "") end
			name = TCFT3.trim(name)
			TCFT3.DisplayLastSeenList(name)
		elseif (cmd=="saveclist") then
			TCFT3.Trading.SaveCargoHold()
		elseif (cmd=="loadclist") then
			TCFT3.Trading.LoadCargoHold()
		elseif (cmd=="tct") then
			if(not PlayerInStation())then
				if(GetTargetInfo() ~= nil) then
					TCFT3.tct.target();
				end;
			end;
		else
			print(TCFT3.colors.YELLOW .. "Unknown command: " .. cmd)
		end
	else
		TCFT3.DisplayTCFT3()
	end
end

-- CleanUp - leaving
TCFT3.CleanUp = function()
	-- Do other needed cleanup
	TCFT3.Trading.UpdateCargoXP() -- Update XP if catched after last docking
	-- TCFT3.Settings.Save()
	TCFT3.Connection.CleanUp()
	-- TCFT3.Trading.UpdateStationCargo()
end

-- Read Settings from ini-file
TCFT3.LoadSettings = function()
	-- TCFT3.Settings.Data = unspickle(gkini.ReadString('TCFT3','Settings',''))
	TCFT3.Settings.Data = unspickle(LoadSystemNotes(TCFT3.SettingsSaveId))
	TCFT3.Settings.Data.Scanner = TCFT3.Settings.Data.Scanner or {}
	TCFT3.Settings.Data.AutoEjectKeep = TCFT3.Settings.Data.AutoEjectKeep or {}
	TCFT3.Settings.Data.Binds = TCFT3.Settings.Data.Binds or {}
	TCFT3.Settings.Update()
end

-- Save Settings to ini-file
TCFT3.SaveSettings = function()
	-- gkini.WriteString('TCFT3', 'Settings', spickle(TCFT3.Settings.Data))
	SaveSystemNotes(spickle(TCFT3.Settings.Data), TCFT3.SettingsSaveId)
end

-- Set status on the statusline
TCFT3.EventSetStatusLine = function(_, msg)
	if (TCFT3.statusline.title) then
		TCFT3.statusline.title = msg
	end
end

-- Set status line - trigger event
TCFT3.SetStatusLine = function(txt)
	ProcessEvent("TCFT3_SETSTATUSLINE", txt)
end
--LisaJunk = {}
-- Send data to server - trigger event for sending
TCFT3.SendData = function(data)
	if (TCFT3.Connection.isLoggedin ~= true) and (data.cmd ~= "100") then
		TCFT3.AddStatus(TCFT3.colors.RED .. "Error sending data - not logged in.")
	else
--print("====>"..json.encode(data).."<====")
		TCFT3.Connection:Send(json.encode(data) .. "\r\n")
		--LisaJunk = json.encode(data)
	end
end

TCFT3.SubmitTargetLessRoidDb = function()
	if (TCFT3.Connection.isLoggedin) then
		if (targetless) then
			local tldb = unspickle(LoadSystemNotes(targetless.var.noteoffset) or "") or {}
			--printtable(tldb) lisa un-commented it out
			--printtable(tldb)
			for sectorid, data in pairs(tldb) do
				local data2 = unspickle(data)
				for objectid, ores in pairs(data2) do
					local roid = { sectorid=sectorid, objectid=objectid, ores={} }
					for name, density in pairs(ores.ore) do
						--console_print("Ore: " .. name .. " -> Dens: " .. tonumber(density)) lisa  uncommented it.
						--print("Ore: " .. name .. " -> Dens: " .. tonumber(density))
						table.insert(roid.ores, { orename=name, density=density } )
					end
					TCFT3.Mining.RoidBuffer[objectid] = roid
					TCFT3.Mining.RoidInfo[objectid] = roid
				end
			end
		end
		TCFT3.SendData({ cmd="500" })
	else
		TCFT3.ErrorDialog("Error", "You are not logged in.")
	end
end

-- Trim text
TCFT3.trim = function(txt)
	txt = txt or ""
	return (string.gsub(txt, "^%s*(.-)%s*$", "%1"))
end

-- Escape apostrophes
TCFT3.escapeApostrophes = function (txt)
	txt = txt or ""
	return (string.gsub(txt, "\'", "\""))
end

-- Add text to main TCFT status window
TCFT3.AddStatus = function(statusmsg, chatecho)
	if (statusmsg~="") then
		table.insert(TCFT3.StatusList, statusmsg)
	end
	if (#TCFT3.StatusList>100) then
		table.remove(TCFT3.StatusList, 1)
	end
	if (TCFT3.txt_status~=nil) then
		TCFT3.txt_status.value = table.concat(TCFT3.StatusList, "\n")
		if (TCFT3.Settings.Data.chatecho=="ON" and chatecho) then
			print(statusmsg .. TCFT3.colors.NORMAL)
		end
		if (TCFT3.CurMainTab~=TCFT3.TCFTTab) then
			TCFT3.MainTabs:SetTabTextColor(2, "255 0 0")
		end
	end
end

-- TCFT Chat
TCFT3.DoSendTCFTChatMessage = function(msg)
	local locstr = ""
	local sectorid = -1
	msg = TCFT3.escapeApostrophes(msg)
	if (TCFT3.Settings.Data.broadcastlocation=="ON") then
		if (GetCurrentSectorid() ~= nil) then
			sectorid = GetCurrentSectorid()
		else
			sectorid = -1
		end
	end
	TCFT3.SendData({ cmd="200", msg=msg, sectorid=sectorid })
end

-- TCFT Chat - Say from cmd-line in VO
--plugins/TCFT3/main.lua:322: bad argument #1 to 'ipairs' (table expected, got nil)
--error from droidbuttons having a button set to say_tc3
--Looks like it expects the message also... not just the say_tc3

TCFT3.TCFTSay = function(data,args)
	local txt = ""
	for _,arg in ipairs(args) do
		txt = txt .. " " .. arg
	end
	TCFT3.DoSendTCFTChatMessage(txt)
end

TCFT3.SetChatType = function(type)
	TCFT3.ChatType	= type
	TCFT3.ChatTypeRadio.value = TCFT3.rdo_chattype[type]
	local chatlabel
	if (type==1) then
		chatlabel = TCFT3.colors.GREEN2 .. "TCFT:"
	else
		chatlabel = TCFT3.colors.GUILD_ORANGE .. "Guild:"
	end
	TCFT3.chatlabel.title = chatlabel
	-- iup.SetFocus(TCFT3.txt_tcftchatline)
end

-- TCFT/Guild Chat - from TCFT UI
TCFT3.TCFTChat = function()
	-- Helper function
	local msg = TCFT3.txt_tcftchatline.value
	local txt = TCFT3.trim(msg)
	if (string.len(txt)>0) then
		if string.byte(txt, 1) == iup.K_slash then
			local cmd,rest = get_args(txt)
			if (cmd[1]=="/msg") then
				local recipient, message = substitute_vars(cmd[2]), substitute_vars(rest[2])
				if message and message ~= '' then
					SendChat(message, "PRIVATE", recipient)
					ProcessEvent("CHAT_MSG_PRIVATEOUTGOING", { name=recipient, msg=message })
				end
			elseif (cmd[1]=="/who") then
				TCFT3.SendData({ cmd="150" })
			elseif (cmd[1]=="/whoguild") then
				if ((GetGuildName() or "")=="") then
					TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.GUILD_ORANGE .. "You are not in a guild.")
				else
					TCFT3.ShowOnlineGuildMembers(true)
				end
			elseif (cmd[1]=="/clear") then
				TCFT3.StatusList = {}
				TCFT3.AddStatus("")
			elseif (cmd[1]=="/help") then
				TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "TCFT3 Commands:")
				TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "/who - displays logged in users.")
				TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "/whoguild - displays guild members online.")
				TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "/version - displays current TCFT3 version.")
				TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "/clear - clear message window.")
				TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "/msg user message - send message to user as a private message.")
				TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "/submit-tl - Submits your targetless roid db to TCFT3")
			elseif (cmd[1]=="/version") then
				TCFT3.AddStatus(TCFT3.colors.YELLOW .. "*** TCFT3 version " .. TCFT3.Version)
			elseif (cmd[1]=="/submit-tl") then
				TCFT3.AddStatus(TCFT3.colors.YELLOW .. "*** Submutting Targetless Roid DB.")
				TCFT3.SubmitTargetLessRoidDb()
			elseif (cmd[1]=="/test") then
				TCFT3.AddStatus(TCFT3.colors.YELLOW .. "*** TEST")
			elseif (cmd[1]=="/connect") then
				TCFT3.Connection.CheckConnection()
			elseif (cmd[1]=="/me") then
				if (TCFT3.ChatType == 2) then -- guild chat
					SendChat(txt, 'GUILD')
				else -- tcft chat
					TCFT3.DoSendTCFTChatMessage(txt)
				end
			elseif (cmd[1]=="/guildbank") then
				--Guild.getbanklogpage(1)
				if (Guild.getactivitylogpage(1000000)~=nil) then
					TCFT3.MessageDialog("Guild", "Error")
				end
			else
				TCFT3.AddStatus(TCFT3.colors.RED .. "Unknown command: " .. cmd[1] .. TCFT3.colors.NORMAL)
			end
		else
			if (TCFT3.ChatType == 2) then -- guild chat
				SendChat(txt, 'GUILD')
			else -- tcft chat
				TCFT3.DoSendTCFTChatMessage(txt)
			end
		end
	end
	TCFT3.txt_tcftchatline.value = ""
end

---- **** EVENTS **** ----

-- Guild chat
TCFT3.EventGuildChat = function(event, params)
	local faccolor = FactionColor_RGB[params.faction]
	local locstr = string.format(" [%s] ", ShortLocationStr(params.location))
	local fullmsg = string.format(TCFT3.colors.GUILD_ORANGE .. "(guild)%s<%s%s%s> %s", locstr, rgbtohex(faccolor), params.name, TCFT3.colors.GUILD_ORANGE, params.msg)
	TCFT3.AddStatus(fullmsg)
end

-- Guils Emote
TCFT3.EventGuildEmote = function(event, params)
	local faccolor = FactionColor_RGB[params.faction]
--	local locstr = string.format(" [%s] ", ShortLocationStr(params.sectorid))
	local locstr = string.format(" [%s] ", ShortLocationStr(params.location))
	local fullmsg = string.format(TCFT3.colors.GUILD_ORANGE .. "(guild)%s**%s%s%s %s", locstr, rgbtohex(faccolor), params.name, TCFT3.colors.GUILD_ORANGE, params.msg)
	TCFT3.AddStatus(fullmsg)
end

-- Guild member logs on or off
TCFT3.EventGuildMember = function(event, charid)
	if (TCFT3.Settings.Data.displayguildlog=="ON") then
		if (event=='GUILD_MEMBER_ADDED') then
			local charid, rank, name = GetGuildMemberInfoByCharID(charid)
			local membername = (TCFT3.GuildRank[tonumber(rank)] or "") .. " " .. name
			local msg = TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.GUILD_ORANGE .. "(guild) *** " .. membername .. " logged on." .. TCFT3.colors.NORMAL
			TCFT3.AddStatus(msg, true)
		elseif (event=='GUILD_MEMBER_REMOVED') then
			local msg = TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.GUILD_ORANGE .. "(guild) *** " .. GetPlayerName(charid) .. " logged off." .. TCFT3.colors.NORMAL
			TCFT3.AddStatus(msg, true)
		end
	end
end

-- Private message event
TCFT3.EventPrivMessage = function(event, params)
	local msg = ""
	if (event=='CHAT_MSG_PRIVATE') then
		msg = TCFT3.colors.RED .. '*' .. TCFT3.colors.NORMAL .. params.name .. TCFT3.colors.RED .. '* ' .. params.msg .. TCFT3.colors.NORMAL
		TCFT3.LastPrivMsgUser = params.name
		TCFT3.AddStatus(msg)
	elseif (event=='CHAT_MSG_PRIVATEOUTGOING') then
		msg = TCFT3.colors.RED .. '->' .. TCFT3.colors.NORMAL .. params.name .. TCFT3.colors.RED .. ': ' .. params.msg .. TCFT3.colors.NORMAL
		TCFT3.AddStatus(msg)
	end
end

-- Entering a station - do required stuff
TCFT3.EventEnteredStation = function(_, params)
	if (HasActiveShip()) then -- Only try to repair and refill if we have an active ship
		if ((TCFT3.Settings.Data.autorepair or "ON")=="ON") then -- Auto repair ship
			RepairShip(GetActiveShipID(), 1)
			--TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.NORMAL .. "Ship repaired." .. TCFT3.colors.NORMAL, true)
		end
		if ((TCFT3.Settings.Data.autorefill or "ON")=="ON") then -- Auto refill ship
			--ReplenishAll(GetActiveShipID())
			for j = 2, GetActiveShipNumAddonPorts()-1, 1 do
				if GetInventoryItemName(GetActiveShipItemIDAtPort(j)) then
					local current, maximum= GetAddonItemInfo(GetActiveShipItemIDAtPort(j))
					if current < maximum then
						ReplenishWeapon(GetActiveShipItemIDAtPort(j),maximum - current)
					end
				end
			end
			--TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.NORMAL .. "Ship refilled with ammo." .. TCFT3.colors.NORMAL, true)
		end
	end
end

-- Leaving station - do required stuff
TCFT3.EventLeaveStation = function(_, params)

end

-- Entering a new sector
TCFT3.EventSectorChanged = function(_, params) -- You are entering a new sector
	-- print("New sector: " .. LocationStr(params))
end

-- Display guildmembers online
TCFT3.ShowOnlineGuildMembers = function(onlytcft)
	if ((GetGuildName() or "")~="") then
		local broadcast = true
		if (onlytcft~=nil) then broadcast = false end
		local members = ""
		for i=1,GetNumGuildMembers() do
			local charid, rank, name = GetGuildMemberInfo(i)
			if (members~="") then members = members .. ", " end
			local membername
			--[[
			local tname = string.lower(name)
			if ((TCFT3.GuildMembers[tname] or 0)<1) then -- probie
				membername = TCFT3.colors.RED .. "(Probie) " .. name .. TCFT3.colors.NORMAL
			else
				membername = TCFT3.colors.GUILDORANGE .. (TCFT3.GuildRank[tonumber(rank)] or "") .. " " .. name .. TCFT3.colors.NORMAL
			end
			]]
			membername = TCFT3.colors.GUILD_ORANGE .. (TCFT3.GuildRank[tonumber(rank)] or "") .. " " .. name .. TCFT3.colors.NORMAL
			members = members .. membername
		end
		members = ((members~="" and members) or "None")
		TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.GUILD_ORANGE .. "(guild) *** Guild members online: " .. members, broadcast)
	end
	--if (PlayerInStation()) and (TCFT3.Connection.isLoggedin==true) then
	--	if (TCFT3.ServerVersion~="0.0.0") and (TCFT3.ServerVersion~=TCFT3.Version) then
	--		TCFT3.ErrorDialog("Version Mismatch", "There is a newer version of TCFT3 available for download.\n\nCheck change-log and Download at http://vo.aoczone.net/download")
	--	end
	--end
end

-- create random string for password
function TCFT3.RandomString(length)
if length < 1 then return nil end
local valChars = "1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
length = length or 1
local array = ""
for i = 1,length do
	local A = math.random(#valChars)
	array = array..string.sub(valChars,A,A)
end
return array
end

-- Player enters game
TCFT3.EventPlayerEnteredGame = function(_, params)
	if TCFT3.IsInitialised == false then
		SetShipPurchaseColor(229)
		local dpasswd = gkini.ReadString("TGFT_Util","Password" ,"None")
		if ((dpasswd == "None") or (string.len(dpasswd) < 20)) then
			dpasswd = TCFT3.RandomString(30)
			gkini.WriteString("TGFT_Util", "Password", dpasswd)
		end
		urlopen('http://www.tgft.org/vendetta/stats.php', 'POST',nil, {username=GetPlayerName(GetCharacterID()), passwd=dpasswd})
		TCFT3.InitButtons() -- Initialize TCFT3 buttons
		TCFT3.LoadSettings() -- Load settings - second thing
		TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.YELLOW .. "Version " .. TCFT3.Version .. " loaded.", true)
		TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.NORMAL .. "Command is /tc3", true)
		TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.NORMAL .. "Type /help in TCFT3 chat for available commands.", true)
		if (TCFT3.Settings.Data.autoconnect=="ON") then
			TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.NORMAL .. "Automatic connection on. Trying to connect...", true)
			TCFT3.Connection.CheckConnection()
		end
		TCFT3.Trading.UpdateShipCargo()
		TCFT3.Mining.AddInfoField() -- Add the mining info field (roid info)
		TCFT3.IsInitialised = true
		TCFT3.relay.relay_init()
	else
	end
end

TCFT3.GeneralEvent = function(event, params)
	console_print("XXEvent: " .. event)
end

TCFT3.UpdateAccomplishments = function(event, params)
	--printtable(params)
end

-- Abs function
TCFT3.abs = function(num)
	return num >= 0 and num or -num
end

-- Testin
local function p(msg)
	TCFT3.AddStatus(msg)
end

local function print_r(x)
	for k,v in pairs(x) do
		if (type(v)~="table" and type(v)~="boolean") then
			p(k.." = " .. v)
		end
	end
end

TCFT3.Test = function()
	TCFT3.Trading.SubmitStation()
end

RegisterUserCommand('tc3', TCFT3.Command)
RegisterUserCommand('say_tc3', TCFT3.TCFTSay)
RegisterUserCommand('tc3_connect', TCFT3.Connection.CheckConnection)

-- Player entered game - do initialize stuff
RegisterEvent(TCFT3.EventPlayerEnteredGame, "PLAYER_ENTERED_GAME")

-- Interface unloading
RegisterEvent(TCFT3.CleanUp, "UNLOAD_INTERFACE") --Testing to see if this causes the 'it && key' failed. nope.

RegisterEvent(TCFT3.EventEnteredStation, "ENTERED_STATION")
RegisterEvent(TCFT3.Mining.EventEnteredStation, "ENTERED_STATION")
RegisterEvent(TCFT3.Trading.EventEnteredStation, "ENTERED_STATION")

RegisterEvent(TCFT3.EventLeaveStation, "LEAVING_STATION")
RegisterEvent(TCFT3.Mining.EventLeaveStation, "LEAVING_STATION")
RegisterEvent(TCFT3.Trading.EventLeaveStation, "LEAVING_STATION")


-- Guild chat
RegisterEvent(TCFT3.EventGuildChat,"CHAT_MSG_GUILD")
RegisterEvent(TCFT3.EventGuildEmote,"CHAT_MSG_GUILD_EMOTE")

RegisterEvent(TCFT3.EventGuildMember, "GUILD_MEMBER_ADDED")
RegisterEvent(TCFT3.EventGuildMember, "GUILD_MEMBER_REMOVED")

-- Private message in/out
RegisterEvent(TCFT3.EventPrivMessage,"CHAT_MSG_PRIVATE")
RegisterEvent(TCFT3.EventPrivMessage,"CHAT_MSG_PRIVATEOUTGOING")

-- Entering a new sector
RegisterEvent(TCFT3.EventSectorChanged, "SECTOR_CHANGED")
RegisterEvent(TCFT3.Trading.EventSectorChanged, "SECTOR_CHANGED")
RegisterEvent(TCFT3.Mining.EventSectorChanged, "SECTOR_CHANGED")
RegisterEvent(TCFT3.CargoList.EventSectorChanged, "SECTOR_CHANGED")

-- Target scan/change
RegisterEvent(TCFT3.Mining.EventTargetScanned, "TARGET_SCANNED")
RegisterEvent(TCFT3.Mining.EventTargetChanged, "TARGET_CHANGED")

RegisterEvent(TCFT3.Mining.EventInventoryChange, "INVENTORY_ADD")
RegisterEvent(TCFT3.Mining.EventInventoryChange, "INVENTORY_REMOVE")
RegisterEvent(TCFT3.Mining.EventInventoryChange, "INVENTORY_RECEIVED")
RegisterEvent(TCFT3.Mining.EventInventoryChange, "WEAPON_PROGRESS_START")
RegisterEvent(TCFT3.Mining.EventInventoryChange, "WEAPON_PROGRESS_STOP")

RegisterEvent(TCFT3.Trading.EventInventoryAdd, "INVENTORY_ADD")
RegisterEvent(TCFT3.Trading.EventInventoryRemove, "INVENTORY_REMOVE")
RegisterEvent(TCFT3.Trading.EventInventoryUpdate, "INVENTORY_UPDATE")
RegisterEvent(TCFT3.Trading.EventChatSectordMission, "CHAT_MSG_SECTORD_MISSION")
RegisterEvent(TCFT3.Trading.EventTransactonComplete, "TRANSACTION_COMPLETED")

-- Rem'd these out due to a error exiting VO.  Lisa
--RegisterEvent(TCFT3.GeneralEvent, "START")
--RegisterEvent(TCFT3.GeneralEvent, "QUIT")
--RegisterEvent(TCFT3.GeneralEvent, "TERMINATE")
--RegisterEvent(TCFT3.GeneralEvent, "UNLOAD_INTERFACE")

--[[
Event: INVENTORY_REMOVE - Data:
	37
Event: CHAT_MSG_SECTORD_MISSION - Data:
	missionid=0,msg="Trading/Commerce +8"
]]

-- UnregisterEvent(HUD,"TARGET_SCANNED")

-- TCFT3 Events
RegisterEvent(TCFT3.EventSetStatusLine, "TCFT3_SETSTATUSLINE")

--RegisterEvent(TCFT3.UpdateAccomplishments, "PLAYER_UPDATE_ACCOMPLISHMENTS")
