--[[
TCFT3 - UI stuff
]]

--[[
***************
SCANNER SECTION
***************
]]

TCFT3.Mining = {}
TCFT3.Mining.OreList = {}

TCFT3.Mining.MineralSearch = {}
TCFT3.Mining.MineralSearch.SortMode = 1
TCFT3.Mining.MineralSearch.LastOreUpdate = 0
TCFT3.Mining.MineralSearch.Results = {}
TCFT3.Mining.MineralSearch.LastItem = ""
TCFT3.Mining.MineralSearch.LastItemBg = 0
TCFT3.Mining.MineralSearch.Cancelled = false

TCFT3.Mining.Scanner = {}
TCFT3.Mining.Scanner.Running = false
TCFT3.Mining.Scanner.ScannedRoids = {}
-- ScannerPort id - the port we have equipped a scanner
TCFT3.Mining.Scanner.ScannerPortId = 0
TCFT3.Mining.Scanner.ScannerRange = 0 -- Longest range of equipped scanner
TCFT3.Mining.Scanner.StationTurnedOff = false -- Did we auto-turnoff scanner when docking?
TCFT3.Mining.Scanner.Timer = Timer()
TCFT3.Mining.Scanner.CurrentObjectId = 0
TCFT3.Mining.Scanner.KnownObjects = {}

TCFT3.Mining.InfoTimer = Timer()

TCFT3.Mining.Scanner.ShipsWithScanners = {}
TCFT3.Mining.Scanner.ShipsWithScanners["Warthog Mineral Extractor"] = 500
TCFT3.Mining.Scanner.ShipsWithScanners["Behemoth Heavy Miner MkII"] = 1000

TCFT3.Mining.CurrentSystem = TCFT3.Mining.CurrentSystem or GetCurrentSystemid()
TCFT3.Mining.LoadedSystem = 0
TCFT3.Mining.LoadSystemCancelled = false

TCFT3.Mining.CurrentSectorid = nil
TCFT3.Mining.RoidBuffer = {} -- Buffer for submitting sector info
TCFT3.Mining.RoidInfo = {} -- Info of roids in this sector
TCFT3.Mining.RoidInfoSystem = {} -- Roid infor for all system.... HEAVY STUFF MAYBE...
TCFT3.Mining.RoidSendBuffer = {}

TCFT3.Mining.OrelistPrSystem = {}

TCFT3.Mining.MiningMap = {}
TCFT3.Mining.MiningMap.SectorMinerals = {}

TCFT3.Mining.LoadOrelistCancelled = false

TCFT3.ScannerThread = nil

dofile("ui/ui_mining.lua")


-- Start scanner
TCFT3.Mining.Scanner.Start = function()
	TCFT3.Mining.Scanner.StationTurnedOff = false
	if (TCFT3.Mining.Scanner.Running) then
		TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.NORMAL .. "Scanner already on." .. TCFT3.colors.NORMAL, true)
		return
	end
	if (TCFT3.Mining.Scanner.FindScannerPort()) then
		TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.NORMAL .. "Starting scanning with scanner found at port: " .. TCFT3.Mining.Scanner.ScannerPortId .. " - Max range: " .. TCFT3.Mining.Scanner.ScannerRange .. TCFT3.colors.NORMAL, true)
		TCFT3.Mining.Scanner.Running = true
		if(targetless) then targetless.api.radarlock = true end
		gkinterface.GKProcessCommand("RadarNone")
		TCFT3.Mining.Scanner.ScanNext()
	else
		TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.RED .. "No scanners found. Could not start scanning." .. TCFT3.colors.NORMAL, true)
		TCFT3.Mining.Scanner.Running = false
	end
	TCFT3.Mining.Scanner.StationTurnedOff = false
end

-- Stop scanner
TCFT3.Mining.Scanner.Stop = function()
	if(targetless) then targetless.api.radarlock = false end
	if (not TCFT3.Mining.Scanner.Running) then
		TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.NORMAL .. "Scanner not running." .. TCFT3.colors.NORMAL, true)
		return
	end
	TCFT3.Mining.Scanner.Running = false
	--RegisterEvent(HUD, "TARGET_CHANGED")
	TCFT3.Mining.Scanner.KillTimer()
	TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.NORMAL .. "Scanner turned off." .. TCFT3.colors.NORMAL, true)
	TCFT3.Mining.Scanner.StationTurnedOff = false
	gkinterface.GKProcessCommand("RadarNone")
end

-- Toggle scanner
TCFT3.Mining.Scanner.Toggle = function()
	if (TCFT3.Mining.Scanner.Running) then
		TCFT3.Mining.Scanner.Stop()
	else
		TCFT3.Mining.Scanner.Start()
	end
end


TCFT3.Mining.Scanner.KillTimer = function()
	if (TCFT3.Mining.Scanner.Timer:IsActive()) then
		TCFT3.Mining.Scanner.Timer:Kill()
	end
end

TCFT3.Mining.Scanner.ScanNext = function()
	if (TCFT3.Mining.Scanner.Running) and (PlayerInStation()==false) then
		gkinterface.GKProcessCommand("RadarNext")
		local nodeid, objectid = radar.GetRadarSelectionID()
		local name, health, dist, factionid, guild, ship = GetTargetInfo()	
		--nodeid does not identify roid per raybondo
		if (objectid~=nil) and (string.match(name, "Asteroid") or string.match(name, "Ice Crystal")) then -- we hit a roid
			if (not TCFT3.Mining.Scanner.ScannedRoids[objectid]) then -- Already scanned this visit of the sector? - if so dont bother scan again
				local name, health, dist, factionid, guild, ship = GetTargetInfo()
				if (name==nil) then
					TCFT3.Mining.Scanner.Timer:SetTimeout(TCFT3.Settings.Data.Scanner.searchtimeout, TCFT3.Mining.Scanner.ScanNext)
				end
				dist = tonumber(dist or -1)
				if (dist>-1) and (dist<=TCFT3.Mining.Scanner.ScannerRange) then -- In scanner range?
					TCFT3.Mining.Scanner.Timer:SetTimeout(TCFT3.Settings.Data.Scanner.scantimeout, TCFT3.Mining.Scanner.ScanNext)
					-- lisa Give the scanner time to work
				else -- Not in scanner range - just continue to next one after searctimeout millisecs
					TCFT3.Mining.Scanner.Timer:SetTimeout(TCFT3.Settings.Data.Scanner.searchtimeout, TCFT3.Mining.Scanner.ScanNext)
				end
			else -- Already scanned this roid
				TCFT3.Mining.Scanner.Timer:SetTimeout(TCFT3.Settings.Data.Scanner.searchtimeout, TCFT3.Mining.Scanner.ScanNext)
			end
		else -- Not a roid
			--if (objectid~=nil) then
				TCFT3.Mining.Scanner.Timer:SetTimeout(TCFT3.Settings.Data.Scanner.searchtimeout, TCFT3.Mining.Scanner.ScanNext)
		end
	else 
		TCFT3.Mining.Scanner.KillTimer()
		gkinterface.GKProcessCommand("RadarNone") --Lisa added.  To un-target after scanning.
	end	
end

-- FindScannerPort - try to find a port with holding a scanner
TCFT3.Mining.Scanner.FindScannerPort = function()
	local NumPorts = GetActiveShipNumAddonPorts()
	local ScannerFound = false
	local MaxRange = 0
	for PortNo=1,NumPorts do
		local ItemId = GetActiveShipItemIDAtPort(PortNo)
		local ipath,Name,quant,mass,sdesc,desc1,desc2,container,classtype,subtype = GetInventoryItemInfo(ItemId)
		if desc1 then
			local srange = string.match(desc1, "Range: (%d+)")
			local range = -1
			if srange then
				range = tonumber(srange)
			end
			if (Name) then	
				if string.match(Name, 'Scanner') then
					if range > 0 then
						ScannerFound = true
						if MaxRange < range then
							TCFT3.Mining.Scanner.ScannerPortId = PortNo
							MaxRange = range
						end
					end
				end
			end
		end
	end
	-- Also check for built-in scanners - for now we have to check on ship-names
	local shipname = GetActiveShipName()
	if (shipname) then
		for name,range in pairs(TCFT3.Mining.Scanner.ShipsWithScanners) do
			if (shipname==name) then
				range = tonumber(range)
				if (MaxRange < range) then
					MaxRange = range
					TCFT3.Mining.Scanner.ScannerPortId = "(Built-in scanner)"
					ScannerFound = true
				end
			end
		end
	end
	if ScannerFound then
		TCFT3.Mining.Scanner.ScannerRange = tonumber(MaxRange)
		return true
	end
	return false
end


--[[
**********************
MINERAL SEARCH SECTION
**********************
]]

-- Do the search - send request to the server
TCFT3.Mining.MineralSearch.DoSearch = function() -- Search for minerals
	local orename = TCFT3.Mining.MineralSearch.OreNameList[TCFT3.Mining.MineralSearch.OreNameList.value]
	local densityfilter = (TCFT3.Mining.MineralSearch.FilterList.value or 0)
	local syssel = tonumber(TCFT3.Mining.MineralSearch.SearchSystem.value)
	local sysid = -1
	if (syssel>1) then
		local system = string.lower(TCFT3.Trading.LookupSystem[syssel])
		local tmp = string.match(system, "^(%S+)")
		sysid = SystemNames[tmp] or -1
	elseif (syssel==1) then -- current sector
		sysid = GetCurrentSectorid()
		sysid = -sysid
	else
		TCFT3.MessageDialog("Mineral Search", "You have to select a system to search in.")
		return
	end
	if (orename) then
		TCFT3.Mining.MineralSearch.Results = {}
		TCFT3.Mining.MineralSearch.Cancelled = false
		TCFT3.ProgressDialog("Receiving Results", "Receiving Search Result, please wait...", 
			function()
				TCFT3.Mining.MineralSearch.Cancelled=true
			end
		)
		TCFT3.SendData({ cmd="600", orename=orename, densityfilter=densityfilter, systemid=sysid })
	end
end

-- Full list of ores for this sector
TCFT3.Mining.MineralSearch.DoSearchAllThisSector = function()
	local sysid = GetCurrentSectorid()
	sysid = -sysid
	TCFT3.Mining.MineralSearch.Results = {}
	TCFT3.Mining.MineralSearch.Cancelled = false
	TCFT3.ProgressDialog("Receiving Results", "Receiving Search Result, please wait...", 
		function()
			TCFT3.Mining.MineralSearch.Cancelled=true
		end
	)
	TCFT3.SendData({ cmd="600", orename="ALL_ORES_AVAILABLE", densityfilter="", systemid=sysid })
end

-- Update search matrix
TCFT3.Mining.MineralSearch.UpdateMineralSearchTable = function() -- Update the matrix table based on TCFT3.Mining.MineralSearch.ResultTable content - sorted by sortmode
	TCFT3.Mining.MineralSearch.OreList:clear()
	if (#TCFT3.Mining.MineralSearch.Results>0) then
		for i, ore in ipairs(TCFT3.Mining.MineralSearch.Results) do
			ore.sector = ShortLocationStr(ore.sectorid)
			ore.temp = -1.0
			TCFT3.Mining.MineralSearch.OreList:additem(ore)
		end
		TCFT3.Mining.MineralSearch.OreList:update()
	else
		TCFT3.Mining.MineralSearch.OreList.numlin = 2
		TCFT3.Mining.MineralSearch.OreList:setcell(2, 3, "  No Matching")
	end
end

TCFT3.Mining.MineralSearch.UpdateOrelist = function() -- Update list of ores (UI)
	TCFT3.Mining.MineralSearch.OreNameList[1] = nil
	-- TCFT3.Mining.MineralSearch.OreNameList[1] = "Rare Ores"
	for i, orename in ipairs(TCFT3.Mining.OreList) do
		TCFT3.Mining.MineralSearch.OreNameList[i] = orename
	end
	TCFT3.Mining.MineralSearch.OreNameList.value = 1
end

TCFT3.Mining.MineralSearch.UpdateTimer = Timer()
TCFT3.Mining.MineralSearch.UpdateDistAndTemp = function()
	local dist = GetTargetDistance()
	if (dist) then
		local range = string.format("%0.1d", dist)
		TCFT3.Mining.MineralSearch.OreList.data.items[line].range = range
		TCFT3.Mining.MineralSearch.OreList:setcell(line, 5, range .. " m ")
		if (TCFT3.Mining.RoidInfo[objid]) then
			local temp = TCFT3.Mining.RoidInfo[objid].temperature or -1
			if (temp>-1) then
				TCFT3.Mining.MineralSearch.OreList:setcell(line, 6, string.format("%0.1f", tonumber(temp)) .. " K ")
			end
		end
	end
end

-- ********************
-- GENERAL MINING STUFF
-- ********************

-- Submit data for current sector (when entering a new sector)
TCFT3.Mining.SubmitSector = function()
	if (TCFT3.Connection.isLoggedin) and (TCFT3.Mining.CurrentSectorId ~= nil) then
		for objid, data in pairs(TCFT3.Mining.Scanner.ScannedRoids) do
			-- Only submit if we have new records in scannedroids
			TCFT3.Mining.RoidBuffer = {}
			for objid, roid in pairs(TCFT3.Mining.RoidInfo) do
				table.insert(TCFT3.Mining.RoidBuffer, roid)
			end
			TCFT3.SendData({ cmd="500" })
			break
		end
	end
end

-- Load data for entered sector
TCFT3.Mining.LoadSector = function()
	if (TCFT3.Connection.isLoggedin) then
		local sectorid = GetCurrentSectorid()
		TCFT3.Mining.RoidInfo = {}
		TCFT3.SendData({ cmd="700", sectorid=sectorid})
	end
end


--**********
-- ORELIST *
--**********

TCFT3.Mining.OrelistPrSystem.UpdateList = function()
	if (TCFT3.Connection.isLoggedin) then
		TCFT3.Mining.OrelistPrSystem.OreList:clear()
		TCFT3.Mining.LoadOrelistCancelled = false
		TCFT3.ProgressDialog("Ore Pr System", "Receiving result, please wait...", 
			function() 
				TCFT3.Mining.LoadOrelistCancelled=true
			end
		)
		TCFT3.SendData({ cmd="730" })
	else
		TCFT3.ErrorDialog("Ore pr System", "Error - you are not logged in.")
	end
end

-- ********************
-- MINING MAP FUNCTIONS
-- ********************

-- Load data for this system
TCFT3.Mining.MiningMap.LoadSystem = function()
	if (TCFT3.Connection.isLoggedin) then
		local syssel = tonumber(TCFT3.Mining.MiningMap.LookupSystem.value)
		if (syssel>0) then
			local sysname = TCFT3.Mining.MiningMap.LookupSystem[syssel]
			local system = string.lower(sysname)
			local tmp = string.match(system, "^(%S+)")
			local systemid = SystemNames[tmp] or -1
			if (systemid>-1) then
				TCFT3.Mining.RoidInfoSystem = {}
				TCFT3.Mining.LoadSystemCancelled = false
				TCFT3.ProgressDialog("Loading System", "Loading system data for\n" .. TCFT3.colors.GREEN2 .. sysname .. TCFT3.colors.NORMAL .. "\nplease wait...", 
					function()
						TCFT3.Mining.LoadSystemCancelled=true
					end
				)
				TCFT3.Mining.CurrentSystem = systemid
print("XX: "..TCFT3.Mining.CurrentSystem)
				TCFT3.SendData({ cmd="710", systemid=systemid })
			else
				TCFT3.ErrorDialog("Load System", "An error occured while loading Systemdata.")
			end
		end
	end
end

-- Update the map if not loaded already
TCFT3.Mining.MiningMap.UpdateMap = function(orename, force)
	local colors = {
		[0]="255 20 20", -- red
		[1]="255 127 20", -- orange
		[2]="255 255 40", -- yellow
		[3]="0 255 0" -- green
	}
	orename = (orename or "")
	local mappath = string.format("lua/maps/system%02dmap.lua", TCFT3.Mining.CurrentSystem)
	TCFT3.Mining.MiningMap.navmap:loadmap(2, mappath, TCFT3.Mining.CurrentSystem - 1)
	
	local color = ""
	for sector, data in pairs(TCFT3.Mining.MiningMap.SectorMinerals) do
		color = nil
		if (orename~="") then
			if (data[orename]~=nil) then
				if (tonumber(data[orename].max)>75.0) then
					color = colors[3]
				elseif (tonumber(data[orename].max)>50.0) then
					color = colors[2]
				elseif (tonumber(data[orename].max)>25.0) then
					color = colors[1]
				elseif (tonumber(data[orename].max)>0.0) then
					color = colors[0]
				end
			else
				color = "0 0 0 128"
			end
		else
			if (tonumber(data["TCFT3AVERAGE"].max)>75.0) then
				color = colors[3]
			elseif (tonumber(data["TCFT3AVERAGE"].max)>50.0) then
				color = colors[2]
			elseif (tonumber(data["TCFT3AVERAGE"].max)>25.0) then
				color = colors[1]
			elseif (tonumber(data["TCFT3AVERAGE"].max)>0.0) then
				color = colors[0]
			end
		end
		if (color) then
			TCFT3.Mining.MiningMap.navmap["COLOR" .. sector] = color
		end
	end
end

-- Click on miningmap ore
TCFT3.Mining.MiningMapClick = function(text, index, selection)
	local oreselected =""
	local idx = tonumber(index)
	if (selection==1) then
		if (idx>1) then
			oreselected = (string.match(text, "^(.-)%sOre") or "")
		end
		TCFT3.Mining.MiningMap.UpdateMap(oreselected)
	end
end

-- UpdateMapInfo - done after syste is loaded
TCFT3.Mining.MiningMap.UpdateMapInfo = function()
	local orenames = {}
	TCFT3.Mining.MiningMap.SectorMinerals = {}
	TCFT3.Mining.RoidCount = {}
	TCFT3.Mining.RoidCountPrOre = {}
	for idx, roid in ipairs(TCFT3.Mining.RoidInfoSystem) do
		local sectorid = tonumber(roid.sectorid)
		TCFT3.Mining.RoidCount[sectorid] = (TCFT3.Mining.RoidCount[sectorid] or 0) + 1
		TCFT3.Mining.RoidCountPrOre[sectorid] = TCFT3.Mining.RoidCountPrOre[sectorid] or {}
		if (TCFT3.Mining.MiningMap.SectorMinerals[sectorid]==nil) then
			TCFT3.Mining.MiningMap.SectorMinerals[sectorid] = { TCFT3AVERAGE={ max=0 } }
		end
		for idx, ore in ipairs(roid.ores) do
			local orename = tostring(ore.orename)
			local density = tonumber(ore.density)
			if (orename~="") then
				if (TCFT3.Mining.MiningMap.SectorMinerals[sectorid][orename]==nil) then
					TCFT3.Mining.MiningMap.SectorMinerals[sectorid][orename] = { name=orename, max=density, min=density }
				end
				TCFT3.Mining.RoidCountPrOre[sectorid][orename] = (TCFT3.Mining.RoidCountPrOre[sectorid][orename] or 0) + 1
				if (density<TCFT3.Mining.MiningMap.SectorMinerals[sectorid][orename].min) then TCFT3.Mining.MiningMap.SectorMinerals[sectorid][orename].min = density end
				if (density>TCFT3.Mining.MiningMap.SectorMinerals[sectorid][orename].max) then TCFT3.Mining.MiningMap.SectorMinerals[sectorid][orename].max = density end
				if (idx>2) then TCFT3.Mining.MiningMap.SectorMinerals[sectorid]["TCFT3AVERAGE"].max = ((TCFT3.Mining.MiningMap.SectorMinerals[sectorid]["TCFT3AVERAGE"].max + density)/2) end
				orenames[orename .. " Ore"] = orenames[orename .. " Ore"] or orename
			end
		end
	end
	-- Populate the ore-list
	local orenames2 = {}
	for orename, tmp in pairs(orenames) do
		table.insert(orenames2, orename)
	end
	table.sort(orenames2)
	TCFT3.Mining.MiningMap.MineralList[1] = nil
	TCFT3.Mining.MiningMap.MineralList[1] = "Average for all Ores"
	local i = 2
	for _, orename in ipairs(orenames2) do
		TCFT3.Mining.MiningMap.MineralList[i] = orename
		i = i + 1
	end
	TCFT3.Mining.MiningMap.MineralList.value = 1
	TCFT3.Mining.MiningMap.UpdateMap()
end

-- Mouse over mining map
TCFT3.Mining.MiningMap.Map_Mouseover = function(index, str)
	local msg = ""
	local num = tonumber(index)
	string.gsub(str, "(.-)|", function(a) msg = msg .. a .. "\n" end)
	if (TCFT3.Mining.MiningMap.SectorMinerals[num]~=nil) then
		msg = msg .. "\nMinerals:\n"
		for name, ore in pairs(TCFT3.Mining.MiningMap.SectorMinerals[num]) do
			if (name~="TCFT3AVERAGE") then
				local numoreroids = TCFT3.Mining.RoidCountPrOre[num][name] or "?"
				msg = msg .. name .. " Ore" .. TCFT3.colors.GREEN2 .. "  (" .. numoreroids .. " roids - " .. string.format("%0.1f", ore.min) .. "-" .. string.format("%0.1f", ore.max) .."%)" .. TCFT3.colors.NORMAL .. "\n"
			end
		end
		msg = msg .. "\nThere are " .. (TCFT3.Mining.RoidCount[num] or "?") .. " roids in the sector.\n\n" .. GetBotSightedInfoForSector(num)
	end
	TCFT3.Mining.MiningMap.Info.value = msg
end

-- *********
-- AutoEject
-- *********
TCFT3.Mining.AutoEjectOn = function()
	TCFT3.Settings.Data.AutoEjectActive = "ON"
	TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.NORMAL .. "AutoEject turned on." .. TCFT3.colors.NORMAL, true)
end

TCFT3.Mining.AutoEjectOff = function()
	TCFT3.Settings.Data.AutoEjectActive = "OFF"
	TCFT3.AddStatus(TCFT3.colors.GREEN2 .. "(TCFT3) " .. TCFT3.colors.NORMAL .. "AutoEject turned off." .. TCFT3.colors.NORMAL, true)
end

TCFT3.Mining.AutoEjectToggle = function()
	if (TCFT3.Settings.Data.AutoEjectActive == "ON") then
		TCFT3.Mining.AutoEjectOff()
	else
		TCFT3.Mining.AutoEjectOn()
	end
end

-- ****************
-- **** EVENTS ****
-- ****************

-- Process mining stuff when entering station
TCFT3.Mining.EventEnteredStation = function(_, params)
	if (TCFT3.Mining.Scanner.Running) then
		TCFT3.Mining.Scanner.Stop()
		TCFT3.Mining.Scanner.StationTurnedOff = true
	end
	TCFT3.Mining.CurrentSectorId = GetCurrentSectorid()
	TCFT3.Mining.SubmitSector()
end

-- Do mining stuff when leaving station
TCFT3.Mining.EventLeaveStation = function(_, params)
	TCFT3.Mining.CurrentSectorId = GetCurrentSectorid() -- Just update current sector id
	if (TCFT3.Mining.Scanner.StationTurnedOff) then
		TCFT3.Mining.Scanner.Start()
	end
end

-- Target is scanned
TCFT3.Mining.EventTargetScanned = function(_, info, nodeid, objectid)
	if (TCFT3.CargoList.Active) then return end -- We are searching for cargo - doens mind the roid info
	nodeid = nodeid or 0
--	if (nodeid==2) then -- We hit a roid -- NOT true.  Lisa.
	local name, health, dist, factionid, guild, ship = GetTargetInfo() -- lisa added so we can get name
	if (string.match(name, "Asteroid") or string.match(name, "Ice Crystal")) then -- we hit a roid, lisa
		info = (info or "")
		if ((objectid or -1)>-1) and ((TCFT3.Mining.Scanner.ScannedRoids[objectid] or 0)~=1) then
			if (not string.find(info, "Object too far to scan")) or (string.find(string.lower(info), "ore")) then -- Out of range or no info - check if we have data for this one
				if (string.find(string.lower(info), "ore")) then
					local ores = {}
					local sectorid = GetCurrentSectorid()
					local temp = -1
					string.gsub(info, "(.-)\n", function(xinfo, percent) 
						if (not string.find(xinfo, "Temperature:")) then 
							string.gsub(xinfo, "(.-)%sOre: (.-)%%", function(name, percent) 
								table.insert(ores, { orename=name, density=percent }) 
							end)
						end
					end)
					local roid = { temperature=temp, sectorid=sectorid, objectid=objectid, ores=ores }
					TCFT3.Mining.RoidInfo[objectid] = roid
					TCFT3.Mining.Scanner.ScannedRoids[objectid] = 1
					TCFT3.Mining.EventTargetChanged()
					HUD:PrintSecondaryMsg(TCFT3.colors.GREEN2 .. "(TCFT3)" .. TCFT3.colors.NORMAL .. " Ore saved.")
				else
					local sectorid = GetCurrentSectorid()
					string.gsub(info, "Temperature:(.-) K", function(temp)
						TCFT3.Mining.RoidInfo[objectid] = TCFT3.Mining.RoidInfo[objectid] or { temperature=-1, sectorid=sectorid, objectid=objectid, ores={ { orename="Unknown", density=0 } } }
						TCFT3.Mining.RoidInfo[objectid].temperature=tonumber(temp)
						TCFT3.Mining.EventTargetChanged()
					end)
				end
			else
				TCFT3.Mining.EventTargetChanged()
			end
		end
	end
end

-- Target Changed
TCFT3.Mining.EventTargetChanged = function(_, params)
	if (TCFT3.Mining.Scanner.Running) or (TCFT3.CargoList.Active) or (targetless.api.radarlock==true) then -- If we are scanning we skip this update to save cpu - its also done in target_scanned event handler
		return
	end
	local nodeid, objectid = radar.GetRadarSelectionID()
-- lisa removed one level of IF's
--	if (nodeid~=nil) and (nodeid==2) then --lisa won't work. Can't identify roids via nodeid. per raybondo.
		if (objectid) then
			local name, health, dist, factionid, guild, ship = GetTargetInfo()
			local txt = ""
			if (string.find(name, "Asteroid")) or (string.find(name, "Ice Crystal")) then --lisa now only way to identify roids
				txt = TCFT3.colors.YELLOW .. name .." #" .. objectid .. TCFT3.colors.NORMAL
				local roidInfo = TCFT3.Mining.RoidInfo[objectid]
				if (roidInfo~=nil) then
					--FadeStop(HUD.scaninfo)
					table.sort(roidInfo.ores, function(a,b) return (tonumber(a.density) or 0)>(tonumber(b.density) or 0) end)
					for idx, ore in ipairs(roidInfo.ores) do
						txt = txt .. " | " .. ore.orename .. ": " .. ore.density .. "%"
					end
					if ((roidInfo.temperature or -1)>-1) then
						txt = txt .. " | " .. TCFT3.colors.GREY2 .. "Temp: " .. string.format("%0.1f", roidInfo.temperature) .. " K"
					end
				else
					txt = txt .. " | " .. TCFT3.colors.RED .. "No data"
				end
				TCFT3.Mining.SetInfo(txt)
			else
				TCFT3.Mining.SetInfo("")
			end
		else
			TCFT3.Mining.SetInfo("")
		end
	-- return iup.CONTINUE
end

-- Entering a new sector
TCFT3.Mining.EventSectorChanged = function(_, params)
	-- Update variables used later in this event
	TCFT3.Mining.SubmitSector()
	TCFT3.Mining.CurrentSectorId = GetCurrentSectorid()
	if (TCFT3.Mining.CurrentSystem ~= GetCurrentSystemid()) then
		TCFT3.Mining.MiningMap.LoadSystemButton.active="YES"
	end
	TCFT3.Mining.CurrentSystem = GetCurrentSystemid()

	if (TCFT3.Settings.Data.autoloadsectordata=="ON") then -- Auto load sector data
		TCFT3.Mining.LoadSector()
	end
	TCFT3.Mining.Scanner.ScannedRoids = {}
end

TCFT3.Mining.EventInventoryChange = function(event, params, p2, p3, p4, p5) -- Inventory change - check for auto jettison
	local CargoMax = GetActiveShipMaxCargo() or 0
	local CargoCurrent = GetActiveShipCargoCount() or 0
	if (TCFT3.Settings.Data.AutoEjectActive == "ON") then
		if (CargoCurrent>0) and (CargoMax-CargoCurrent<=16) then
			local CurrentInventory = GetShipInventory(GetActiveShipID())
			for idx,itemid in ipairs(CurrentInventory.cargo) do
				local orename = GetInventoryItemName(itemid)
				local ore = string.match(orename, "^Premium%s(.-%sOre)$") or string.match(orename, "^(.-%sOre)$")
				if (ore) and (TCFT3.Settings.Data.AutoEjectKeep[ore]~="ON") then -- We found ore and dont have setting to keep this one
					if (TCFT3.Settings.Data.SoundCargoAutoeject~= "None") then
						gksound.GKPlaySound(TCFT3.Sounds[TCFT3.Settings.Data.SoundCargoAutoeject], 1.0)
					end
					JettisonSingle(itemid, 200)
				end
			end
		end
	end	
	if (CargoMax>0) and (CargoCurrent==CargoMax) then
		if (TCFT3.Settings.Data.SoundCargoholdFull~= "None") then
			gksound.GKPlaySound(TCFT3.Sounds[TCFT3.Settings.Data.SoundCargoholdFull], 1.0)
		end
	end
end


TCFT3.Mining.AddInfoField = function()
	-- TCFT3.Mining.Info = iup.label{ title="", expand="NO", alignment="ARIGHT", font=Font.H4*HUD_SCALE }
	--[[
	TCFT3.Mining.InfoBox = iup.vbox {
		visible="YES",
		iup.fill {},
		iup.hbox {
			iup.fill {},
			iup.hudrightframe {
				iup.vbox {
					expand="NO",
					iup.hudrightframe {
						border="0 0 0 0",
						iup.hbox {
						bgcolor="255 0 0 192",
							expand="HORIZONTAL",
							iup.fill{},
							iup.label { title=TCFT3.colors.GREEN2 .. "* TCFT3 *", alignment="ACENTER", expand="NO", font=Font.H4*HUD_SCALE*1.05 },
							iup.fill{},
						},
					},
					iup.fill { size=3 },
					iup.hudrightframe {
						border="0 0 0 0",
						iup.vbox {
							TCFT3.Mining.Info,
							expand="YES",
							margin="7x7",
						},
						-- size=HUDSize(.12).."x",
						expand="YES",
						-- size=HUDSize(.15),
					},
				},
			},
			iup.fill { size=HUDSize(.25) },
		},
		iup.fill {},
	}
	]]


	TCFT3.Mining.Info = iup.label{ title="TEST", expand="NO", alignment="ALEFT", font=Font.H4*HUD_SCALE }

	TCFT3.Mining.InfoBox = iup.vbox {
		visible="NO",
		iup.fill {},
		iup.hbox {
			iup.fill {},
			iup.hudrightframe {
				border="2 2 2 2",
				iup.vbox {
					expand="NO",
					iup.hudrightframe {
						border="0 0 0 0",
						iup.hbox {
							iup.fill {},
							iup.label { title=TCFT3.colors.GREEN2 .. " * TCFT3 * ", alignment="ACENTER", expand="NO", font=Font.H4*HUD_SCALE },
							iup.fill {},
							margin="2x2",
						},
					},
					iup.fill { size=3 },
					iup.hudrightframe {
						border="0 0 0 0",
						iup.hbox {
							TCFT3.Mining.Info,
							margin="10x3",
						},
					},
				},
			},
			iup.fill {},
		},
		iup.fill { size=3 },
	}
	
	iup.Append(HUD.pluginlayer, TCFT3.Mining.InfoBox)
	
	--[[
	local scaninfoprnt = iup.GetParent(HUD.scaninfo)
	if (scaninfoprnt~=nil) then
		iup.Detach(HUD.scaninfo)
		local infobox = iup.hbox {
			alignment="ARIGHT",
			HUD.scaninfo, iup.fill { size="20" },
			TCFT3.Mining.Info,
			expand="YES",
		}
		-- HUD.scaninfo.expand="NO"
		iup.Append(scaninfoprnt, infobox)
	end
	]]
end

-- Set info below scaninfo in HUD
TCFT3.Mining.SetInfo = function(infotxt)
	if (TCFT3.Mining.Info~=nil) then
		TCFT3.Mining.Info.title = infotxt
		if (TCFT3.Mining.InfoBox~=nil) then
			TCFT3.Mining.InfoBox.visible= (infotxt~="" and "YES") or "NO"
		end
	end
end

