--[[
TCFT3
(c) By Plozi
Version 1.0.0

** Changelog

]]

TCFT3.Settings = {}
TCFT3.Settings.Debug = 0
TCFT3.Settings.Data = {}
TCFT3.Settings.Data.Scanner = {}
TCFT3.Settings.Data.Binds = {}
TCFT3.Settings.Data.AutoEjectKeep = {}

dofile("ui/ui_settings.lua")

TCFT3.Settings.Update = function() -- Init after changes to settings
	TCFT3.Settings.DoBinds()
	TCFT3.Settings.UpdateButtons()
end

-- Save settings - then call main savesettings to save to ini-file
TCFT3.Settings.Save = function()
	-- General settings
	TCFT3.Settings.Data.username = TCFT3.txt_username.value or ""
	TCFT3.Settings.Data.password = TCFT3.txt_password.value or ""

	TCFT3.Settings.Data.chatecho = TCFT3.chk_chatecho.value or "ON"
	TCFT3.Settings.Data.autoconnect = TCFT3.chk_autoconnect.value or "OFF"
	TCFT3.Settings.Data.displayguildlog = TCFT3.chk_displayguildlog.value or "ON"
	TCFT3.Settings.Data.autorepair = TCFT3.chk_autorepair.value or "ON"
	TCFT3.Settings.Data.autorefill = TCFT3.chk_autorefill.value or "ON"
	TCFT3.Settings.Data.broadcastlocation = TCFT3.chk_broadcastlocation.value or "ON"
	TCFT3.Settings.Data.tcftchattomainchat = TCFT3.chk_tcftchattomainchat.value or "OFF"
	TCFT3.Settings.Data.autoloadsectordata = TCFT3.chk_autoloadsectordata.value or "OFF"
	TCFT3.Settings.Data.stationbuttons = TCFT3.chk_stationbuttons.value or "ON"
	TCFT3.Settings.Data.pdabuttons = TCFT3.chk_pdabuttons.value or "ON"
	TCFT3.Settings.Data.capshipbuttons = TCFT3.chk_capshipbuttons.value or "ON"
	TCFT3.Settings.Data.chk_autonotifylastseen = TCFT3.chk_autonotifylastseen.value or "ON"
	TCFT3.Settings.Data.chk_autonotifyhud = TCFT3.chk_autonotifyhud.value or "ON"
	
	TCFT3.Settings.Data.SoundCargoholdFull = TCFT3.MiningSoundList[TCFT3.MiningSoundList.value] or "None"
	TCFT3.Settings.Data.SoundCargoAutoeject = TCFT3.MiningSoundListAutoeject[TCFT3.MiningSoundListAutoeject.value] or "None"
	-- Asteroidscanner settings
	TCFT3.Settings.Data.Scanner.searchtimeout = tonumber(TCFT3.Mining.Scanner.txt_searchtimeout.value) or 750
	TCFT3.Settings.Data.Scanner.scantimeout = tonumber(TCFT3.Mining.Scanner.txt_scantimeout.value) or 500
	
	local binds = TCFT3.Settings.GetBinds()
	TCFT3.Settings.Data.Binds = {}
	for key, bind in pairs(binds) do
		TCFT3.Settings.Data.Binds[key] = TCFT3.Binds[key].value
	end

	-- Relay settings
	TCFT3.Settings.Data.relayServer = "34.205.215.112" or TCFT3.txt_relayServer.value
	TCFT3.Settings.Data.relayServerPort = "11000" or TCFT3.txt_relayServerPort.value
	TCFT3.Settings.Data.relayServerPassword = "tgftrulez" or TCFT3.txt_relayServerPassword.value

	TCFT3.Settings.Update()
	
	TCFT3.SaveSettings()
	-- TCFT3.AddStatus(TCFT3.colors.YELLOW .. "Settings saved.")
	TCFT3.MessageDialog("Save Settings", "Settings saved.")

end

-- Update settings window when settings tab is activated
TCFT3.Settings.UpdateUI = function()
	-- General settings
	TCFT3.txt_username.value = TCFT3.Settings.Data.username or ""
	TCFT3.txt_password.value = TCFT3.Settings.Data.password or ""
	TCFT3.chk_chatecho.value = TCFT3.Settings.Data.chatecho or "ON"
	TCFT3.chk_autoconnect.value = TCFT3.Settings.Data.autoconnect or "OFF"
	TCFT3.chk_displayguildlog.value = TCFT3.Settings.Data.displayguildlog or "ON"
	TCFT3.chk_autorepair.value = TCFT3.Settings.Data.autorepair or "ON"
	TCFT3.chk_autorefill.value = TCFT3.Settings.Data.autorefill or "ON"
	TCFT3.chk_broadcastlocation.value = TCFT3.Settings.Data.broadcastlocation or "ON"
	TCFT3.chk_tcftchattomainchat.value = TCFT3.Settings.Data.tcftchattomainchat or "OFF"
	TCFT3.chk_autoloadsectordata.value = TCFT3.Settings.Data.autoloadsectordata or "OFF"
	TCFT3.chk_stationbuttons.value = TCFT3.Settings.Data.stationbuttons or "ON"
	TCFT3.chk_pdabuttons.value = TCFT3.Settings.Data.pdabuttons or "ON"
	TCFT3.chk_capshipbuttons.value = TCFT3.Settings.Data.capshipbuttons or "ON"
	TCFT3.chk_autonotifylastseen.value = TCFT3.Settings.Data.chk_autonotifylastseen or "ON"
	TCFT3.chk_autonotifyhud.value = TCFT3.Settings.Data.chk_autonotifyhud or "ON"
	
	for idx, label in ipairs(TCFT3.SoundLabels) do
		if (label==TCFT3.Settings.Data.SoundCargoholdFull) then
			TCFT3.MiningSoundList.value = idx
		end
		if (label==TCFT3.Settings.Data.SoundCargoAutoeject) then
			TCFT3.MiningSoundListAutoeject.value = idx
		end
	end
	
	-- Relay settings
	TCFT3.txt_relayServer.value = TCFT3.Settings.Data.relayServer or "34.205.215.112"
	TCFT3.txt_relayServerPort.value = TCFT3.Settings.Data.relayServerPort or "11000"
	TCFT3.txt_relayServerPassword.value = TCFT3.Settings.Data.relayServerPassword or "tgftrulez"

	-- Asteroidscanner settings
	TCFT3.Mining.Scanner.txt_searchtimeout.value = tonumber(TCFT3.Settings.Data.Scanner.searchtimeout) or 750
	TCFT3.Mining.Scanner.txt_scantimeout.value = tonumber(TCFT3.Settings.Data.Scanner.scantimeout) or 500
	local binds = TCFT3.Settings.GetBinds()
	for key, bind in pairs(binds) do
		TCFT3.Binds[key].value = (TCFT3.Settings.Data.Binds[key] or "")
	end
	TCFT3.AutoEjectActive.value = (TCFT3.Settings.Data.AutoEjectActive or "OFF")
	for orename, value in pairs(TCFT3.Settings.Data.AutoEjectKeep) do
		if (TCFT3.AutoEjectOresKeep[orename]~=nil) then
			TCFT3.AutoEjectOresKeep[orename].value = (value or "OFF")
		end
	end
end


-- Update tcft buttons
TCFT3.Settings.UpdateButtons = function()
	if (TCFT3.ButtonsAdded==true) then return end
	-- TCFT3.PDASecInfo, TCFT3.CapshipSecInfo, TCFT3.StationSecInfo
	-- Station buttons
	if ((TCFT3.Settings.Data.stationbuttons or "ON")=="ON") and (TCFT3.StationSecInfo~=nil) then
		TCFT3.AddButtons(TCFT3.StationSecInfo)
	else
		TCFT3.RemoveButtons(TCFT3.StationSecInfo)
	end
	-- PDAButtons
	if ((TCFT3.Settings.Data.pdabuttons or "ON")=="ON") and (TCFT3.PDASecInfo~=nil) then
		TCFT3.AddButtons(TCFT3.PDASecInfo)
	else
		TCFT3.RemoveButtons(TCFT3.PDASecInfo)
	end

	-- Capship buttons
	if ((TCFT3.Settings.Data.capshipbuttons or "ON")=="ON") and (TCFT3.CapshipSecInfo~=nil) then
		TCFT3.AddButtons(TCFT3.CapshipSecInfo)
	else
		TCFT3.RemoveButtons(TCFT3.CapshipSecInfo)
	end
end

-- Return bind settings
TCFT3.Settings.GetBinds = function()
	local binds = {
		TC3 = { desc="Show TCFT3", alias="", command="TC3", control=TCFT3.Binds.TC3 },
		SAY_TC3 = { desc="TCFT3 chat", alias="TCFT3_SAY 'prompt say_TC3'", command="TCFT3_SAY", control=TCFT3.Binds.SAY_TC3 },
		CARGOLIST = { desc="Show cargolist", alias="TCFT3_CARGOLIST_SHOW 'TC3 cargolist'", command="TCFT3_CARGOLIST_SHOW", control=TCFT3.Binds.CARGOLIST },
		SCANNER_TOGGLE = { desc="Toggle scanner on/off", alias="TCFT3_SCANNER_TOGGLE 'TC3 scanner toggle'", command="TCFT3_SCANNER_TOGGLE", control=TCFT3.Binds.SCANNER_TOGGLE },
		AUTOEJECT_TOGGLE = { desc="Toggle AutoEject on/off", alias="TCFT3_AUTOEJECT_TOGGLE 'TC3 autoeject toggle'", command="TCFT3_AUTOEJECT_TOGGLE", control=TCFT3.Binds.AUTOEJECT_TOGGLE },
		LAST_SEEN_PROMPT = { desc="Last Seen", alias="TCFT3_LAST_SEEN 'TC3 lastseen'", command="TCFT3_LAST_SEEN", control=TCFT3.Binds.LAST_SEEN_PROMPT }
	}
	return binds
end


-- Test if binds conflicts
TCFT3.Settings.TestBinds = function()
	local msg = ""	
	local binds = TCFT3.Settings.GetBinds()
	for key, bind in pairs(binds) do
		local bindkey = TCFT3.Settings.Data.Binds[key] or ""
		if (bindkey~="") then
			local code = gkinterface.GetInputCodeByName(bindkey)
			if (code) then
				local key = gkinterface.GetNameForInputCode(code)
				local cmd = gkinterface.GetCommandForKeyboardBind(code)
				if (cmd) then
					if (not string.match(string.lower(cmd), "TCFT3")) and (not string.match(string.lower(cmd), "TC3")) then
						msg = msg .. "The key '" .. key .. "' are already bound to command '" .. cmd .. "'\n"
					end
				end
			end
		end
	end
	if (msg=="") then
		TCFT3.MessageDialog("Keyboard Binds", "No bind conflicts")
	else
		TCFT3.MessageDialog("Keyboard Binds", "The following bind conflicts were found:\n\n" .. msg)
	end
	--local code = gkinterface.GetInputCodeByName('G')
	--print(code)
	--print(gkinterface.GetNameForInputCode(code))
	--print( gkinterface.GetCommandForKeyboardBind(code) )
	--gkinterface.UnbindCommand(cmd)
	--gkinterface.BindCommand(inputcode, cmd)
	--gkinterface.GKProcessCommand("alias TCFT3_SAY 'prompt say_TC3'")
	--gkinterface.GKProcessCommand("bind 'P' TCFT3_SAY")

end

-- Do binds for user
TCFT3.Settings.DoBinds = function()
	local binds = TCFT3.Settings.GetBinds()
	for key, bind in pairs(binds) do
		local bindkey = TCFT3.Settings.Data.Binds[key] or ""
		if (bindkey~="") and ((bind.command or "")~="") then
			local code = gkinterface.GetInputCodeByName(bindkey)
			if ((bind.alias or "")~="") then -- we need some alias here
				gkinterface.GKProcessCommand("alias " .. bind.alias)
			end
			gkinterface.GKProcessCommand("bind '" .. bindkey .. "' " .. bind.command)
		end
	end
end
