--[[
    TargetTools
        Made by: Seryn
        Edited by "Scion Spy" for (TCFT3)
]]



TCFT3.tct = {}; --This Plug "Tct";
TCFT3.tct.ti = {}; --TargetInfo;
TCFT3.tct.scgrab = {}; --ScannerGrab;


function TCFT3.tct.tigrab()
    TCFT3.tct.ti.name, TCFT3.tct.ti.health, TCFT3.tct.ti.dist, TCFT3.tct.ti.factionid, TCFT3.tct.ti.guild, TCFT3.tct.ti.ship = GetTargetInfo();

-- get object id to match later
  local ob, nod = radar.GetRadarSelectionID();
    TCFT3.tct.ti.faction = "";
    TCFT3.tct.ti.shield = nil;
    TCFT3.tct.ti.object = ob;
    TCFT3.tct.ti.node = nod;

--If we have a target,
    if TCFT3.tct.ti.name then
        TCFT3.tct.ti.charid = GetCharacterIDByName(TCFT3.tct.ti.name);
        local _, shield = GetPlayerHealth(GetCharacterIDByName(TCFT3.tct.ti.name));
        TCFT3.tct.ti.nodeid = GetPlayerNodeID(TCFT3.tct.ti.charid);
        TCFT3.tct.ti.dist = math.ceil(TCFT3.tct.ti.dist);

        --If target has health.
            if TCFT3.tct.ti.health ~= nil then
                TCFT3.tct.ti.health = math.floor(TCFT3.tct.ti.health*100)
            end;

        --If target has a shield.
            if shield then
                TCFT3.tct.ti.shield = math.floor(shield)
            end;

        --If target has a guild.
            if (TCFT3.tct.ti.guild and TCFT3.tct.ti.guild ~= "") then
                TCFT3.tct.ti.name = "["..tostring(TCFT3.tct.ti.guild).."] "..TCFT3.tct.ti.name
            end;

        --Get target Faction Name.
            if TCFT3.tct.ti.factionid == 1 then
                TCFT3.tct.ti.faction = "Itani";
            elseif TCFT3.tct.ti.factionid == 2 then
                TCFT3.tct.ti.faction = "Serco";
            elseif TCFT3.tct.ti.factionid == 3 then
                TCFT3.tct.ti.faction = "UIT";
            elseif TCFT3.tct.ti.factionid == 4 then
                TCFT3.tct.ti.faction = "TPG";
            elseif TCFT3.tct.ti.factionid == 5 then
                TCFT3.tct.ti.faction = "BioCom";
            elseif TCFT3.tct.ti.factionid == 6 then
                TCFT3.tct.ti.faction = "Valent";
            elseif TCFT3.tct.ti.factionid == 7 then
                TCFT3.tct.ti.faction = "Orion";
            elseif TCFT3.tct.ti.factionid == 8 then
                TCFT3.tct.ti.faction = "Axia";
            elseif TCFT3.tct.ti.factionid == 9 then
                TCFT3.tct.ti.faction = "Corvus";
            elseif TCFT3.tct.ti.factionid == 10 then
                TCFT3.tct.ti.faction = "Tunguska";
            elseif TCFT3.tct.ti.factionid == 11 then
                TCFT3.tct.ti.faction = "Aeolus";
            elseif TCFT3.tct.ti.factionid == 12 then
                TCFT3.tct.ti.faction = "Ineubis";
            elseif TCFT3.tct.ti.factionid == 13 then
                TCFT3.tct.ti.faction = "Xang Xi";
            elseif TCFT3.tct.ti.factionid == 99 then
                TCFT3.tct.ti.faction = "DEV";
            else
                TCFT3.tct.ti.faction = "Unaligned";
            end
        return TCFT3.tct.ti;
    else
        --We don't have a target.
            --Do nothing.
    end
end



TCFT3.tct.scinfo = {}; --ScanInfo
TCFT3.tct.scinfo.content = "";
TCFT3.tct.scinfo.objectid = "none";

function TCFT3.tct.scgrab:OnEvent(scaninfo, nodeid, objectid)
    TCFT3.tct.scinfo.sc = scaninfo
    TCFT3.tct.scinfo.node = nodeid

-- save objectid to match later
	TCFT3.tct.scinfo.objectid = objectid
	TCFT3.tct.scinfo.content = ""
	TCFT3.tct.scinfo.temp = ""
    TCFT3.tct.scinfo.temp2 = ""

--If we have a target.
    if TCFT3.tct.scinfo.node then

    --If our target is too far away to scan.
		if string.find(TCFT3.tct.scinfo.node, "Object too far to scan") then
            TCFT3.tct.scinfo.content = ""

    --If we're targeting an astroid and are within scanner range.
		elseif string.find(TCFT3.tct.scinfo.node, "Ore:") then
			TCFT3.tct.scinfo.temp = ", containing "..TCFT3.tct.scinfo.node.. "."
			TCFT3.tct.scinfo.temp2 = string.gsub(TCFT3.tct.scinfo.temp, "\n", ", ")
			TCFT3.tct.scinfo.content = string.gsub(TCFT3.tct.scinfo.temp2, ":,", ":")
            TCFT3.tct.scinfo.content = string.gsub(TCFT3.tct.scinfo.content, ", %.", ".")

    --If our target is too far away to scan.
		elseif string.find(TCFT3.tct.scinfo.node, "Ship too far to scan") then
            TCFT3.tct.scinfo.content = ""

    --If our target's cargo hold is empty.
		elseif string.find(TCFT3.tct.scinfo.node, "Cargo Hold Empty") then
            TCFT3.tct.scinfo.content = ", cargo hold empty"

    --If our target has items in its cargo bay.
		elseif string.find(TCFT3.tct.scinfo.node, "Cargo:") then
			TCFT3.tct.scinfo.temp = ", carrying "..TCFT3.tct.scinfo.node
			TCFT3.tct.scinfo.temp2 = string.gsub(TCFT3.tct.scinfo.temp, "\n", ", ")
            TCFT3.tct.scinfo.content = string.gsub(TCFT3.tct.scinfo.temp2, ", %.", ".")

    --Not too sure...
		elseif string.find(TCFT3.tct.scinfo.node, "") then
			TCFT3.tct.scinfo.content = ", no cargo info"
        else
        --Also not too sure...
			TCFT3.tct.scinfo.content = TCFT3.tct.scinfo.node
		end
		return TCFT3.tct.scinfo
	end
end

RegisterEvent(TCFT3.tct.scgrab, "TARGET_SCANNED")



function TCFT3.tct.target()
    TCFT3.tct.ti = TCFT3.tct.tigrab();

    -- check if this ship has been scanned
    local objectid = TCFT3.tct.ti.object
    local objectinfo = TCFT3.tct.scinfo.objectid
    if objectid ~= objectinfo then
        TCFT3.tct.scinfo = {};
        TCFT3.tct.scinfo.content = "";
        TCFT3.tct.scinfo.objectid = "none";
    end;

    if TCFT3.tct.ti then
    --If our target is an astroid.
        if string.find(TCFT3.tct.ti.name, "Asteroid") or string.find(TCFT3.tct.ti.name, "Ice Crystal") then
            local msg = "Target: " ..TCFT3.tct.ti.name.."" ..TCFT3.tct.scinfo.content
            TCFT3.DoSendTCFTChatMessage(msg); --Send to (TCFT3)
            --msg = "Target: Ice Crystal, 100% Aquen."

    --If our target is a vessel, without shields.
        elseif TCFT3.tct.ti.ship ~= nil and TCFT3.tct.ti.shield == nil then
            local msg = TCFT3.tct.ti.name.." is piloting a "..TCFT3.tct.ti.ship.. " ("..TCFT3.tct.ti.health.."%) @"..TCFT3.tct.ti.dist.. "m" ..TCFT3.tct.scinfo.content..".";

            --msg = "[TAG]<Player> is piloting a <SHIP> (100%) @782m."
            TCFT3.DoSendTCFTChatMessage(msg); --Send to (TCFT3)

    --If our target is a vessel, with shields.
        elseif TCFT3.tct.ti.ship ~= nil and TCFT3.tct.ti.shield then
            local msg = TCFT3.tct.ti.name.." is piloting a "..TCFT3.tct.ti.ship.. " ("..TCFT3.tct.ti.health.."% Hull & "..TCFT3.tct.ti.shield.."% Shields) @"..TCFT3.tct.ti.dist.. "m" ..TCFT3.tct.scinfo.content..".";

            --msg = "[TAG]<Player> is piloting a <SHIP> (100% Hull & 100% Shields) @782m."
            TCFT3.DoSendTCFTChatMessage(msg); --Send to (TCFT3)

    --If our tarhet is a random object.
        elseif TCFT3.tct.ti.name then
            local msg = "Targeting: "..TCFT3.tct.ti.name..", @"..ti.dist.. "m."
            --msg = "Targeting: <object>, @782m."
            TCFT3.DoSendTCFTChatMessage(msg); --Send to (TCFT3)

    --There's nothing left this target could be...
        else --But... So we don't accidentally crash the client.
            local msg = "Un-identified target....??";
            TCFT3.DoSendTCFTChatMessage(msg); --Send to (TCFT3)
            TCFT3.DebugPrint("(TCFT3) (TC-Target) 'plugins/TCFT3/tct.lua' -> \"Un-identified objects?\"");
        end

    else --ERR Something's broke.. (The below should never run, but just in case..)
        print(TCFT3.colors.GREEN2 .. "(TCFT3) "..TCFT3.colors.GREEN.."(TC-Target) " .. TCFT3.colors.INDIAN_RED .. "Well... This Shouldn't happen....");
        TCFT3.DebugPrint("(TCFT3) (TC-Target) 'plugins/TCFT3/tct.lua' -> Something's not right..");
    end


end; --Function TCFT3.tct.target();
