--[[
TCFT3
(c) By Plozi
Version 1.0.0

** Changelog

]]


TCFT3.CargoList.CreateMainWindow = function()

	if (TCFT3.CargoList.ItemList==nil) then
		TCFT3.CargoList.ItemList = TCFT3.MatrixList:new()
		TCFT3.CargoList.ItemList:addcolumn(TCFT3.MatrixList.column.new("itemname", "Item Name", "ALEFT", { "S:A:itemname", "N:A:distance" }, 60))
		TCFT3.CargoList.ItemList:addcolumn(TCFT3.MatrixList.column.new("distance", "Distance", "ARIGHT", { "N:A:distance", "S:A:itemname" }, 20, { postfix=" m", format="%0.1f" } ))
		TCFT3.CargoList.ItemList:addcolumn(TCFT3.MatrixList.column.new("cargocu", "Cargo CU", "ARIGHT", { "N:A:cargocu" }, 20, { postfix=" cu", format="%d" }))
		TCFT3.CargoList.ItemList:set_sortcol(2)
		TCFT3.CargoList.ItemList:init()

		TCFT3.CargoList.ItemList:setclickcb(
			function(self, line, col) -- click
				if (line==0) then
					TCFT3.CargoList.SortCol = col
					TCFT3.CargoList.UpdateCargoList()				
					return iup.IGNORE
				else
					local tmp = TCFT3.CargoList.ItemList:getitem(line)
					if (tmp~=nil) and (tmp.objid~=nil) and (tmp.nodeid~=nil) then
						if(targetless) then targetless.api.radarlock = true end
						radar.SetRadarSelection(tmp.nodeid, tmp.objid)
						if(targetless) then targetless.api.radarlock = false end
						TCFT3.CargoList.UserSelectedItem = true
					end
				end
			end
		)
	end
	
	TCFT3.CargoList.closeBtn = TCFT3.CargoList.closeBtn or iup.stationbutton {
		title = "Close",
		ALIGNMENT="ACENTER",
		EXPAND="NO",
		action = function(self)
			HideDialog(TCFT3.CargoList.MainWindow)
		end
	}

	TCFT3.CargoList.refreshBtn = TCFT3.CargoList.refreshBtn or iup.stationbutton {
		title = "Refresh (ENTER)",
		ALIGNMENT="ACENTER",
		EXPAND="NO",
		action = function(self)
			TCFT3.CargoList.Refresh()
		end,
	}
	
	TCFT3.CargoList.status = TCFT3.CargoList.status or iup.text { value="", expand="HORIZONTAL", readonly="YES", border="NO", bgcolor="40 40 40 128 *", marign="2x4" }

	local focusgrabber = iup.canvas {size="1x1", border="NO", expand="NO" }
	TCFT3.CargoList.MainWindow = TCFT3.CargoList.MainWindow or iup.dialog {
		iup.stationhighopacityframe {
			iup.vbox {
				margin="5x5",
				iup.hbox {
					iup.fill{}, iup.label { title="TCFT3 Cargolist", font=Font.H3*HUD_SCALE }, iup.fill{},
				},
				iup.hbox {
					TCFT3.CargoList.ItemList,
				},
				focusgrabber, 
				iup.hbox {
					iup.vbox {
						iup.fill { size="10"},
						iup.hbox {
							iup.fill{ size="4" }, TCFT3.CargoList.status, iup.fill{}, TCFT3.CargoList.refreshBtn, iup.fill{ size="4" }, TCFT3.CargoList.closeBtn,
						},
					},					
				},
			},
		},
		size="%40x%60",
		bgcolor="0 0 0 0 *",
		border="NO",menubox="NO",resize="NO",
		defaultesc=TCFT3.CargoList.closeBtn,
		defaultenter=TCFT3.CargoList.refreshBtn,
		defaultfocus=focusgrabber,
		topmost="YES",
		modal="YES",
		alignment="ACENTER",
		bgcolor="40 40 40 128 *",
		show_cb = function(self)
			TCFT3.CargoList.refreshBtn.active="YES"
			TCFT3.CargoList.SelectedNodeId, TCFT3.CargoList.SelectedObjectId = radar.GetRadarSelectionID()
			if (not TCFT3.CargoList.SectorScanned) then
				TCFT3.CargoList.Refresh()
			end
			iup.SetFocus(TCFT3.CargoList.refreshBtn)
		end,
		hide_cb = function()
			TCFT3.CargoList.Timer:Kill()
			if (not TCFT3.CargoList.UserSelectedItem) then
				if(targetless) then targetless.api.radarlock = true end
				if (TCFT3.CargoList.SelectedObjectId==nil) then
					gkinterface.GKProcessCommand("RadarNone")
				else
					radar.SetRadarSelection(TCFT3.CargoList.SelectedNodeId, TCFT3.CargoList.SelectedObjectId)
				end
				if(targetless) then targetless.api.radarlock = false end
			end
		end,
		map_cb = function()
			TCFT3.CargoList.ItemList:map()
		end,
	}
end
