--[[
Guild functions
]]

local function createGuildActivityTab()
	local container

	TCFT3.GuildBank.Activity = TCFT3.MatrixList:new()
	TCFT3.GuildBank.Activity:addcolumn(TCFT3.MatrixList.column.new("date", "Date", "ARIGHT", { "S:D:date" }, 10))
	TCFT3.GuildBank.Activity:addcolumn(TCFT3.MatrixList.column.new("activity", "Activity", "ALEFT", { "S:A:activity" }, 90))
	TCFT3.GuildBank.Activity:init()
	
	TCFT3.GuildBank.ActivityPage = iup.label { title="Guild Activity Page 1", expand="HORIZONTAL", font=Font.H3*HUD_SCALE }
	
	TCFT3.GuildBank.ActivityFirstBtn = iup.stationbutton { 
		title="<< First",
		action = function(self)
			TCFT3.GuildActivity.CurrentPage = 1
			TCFT3.GuildBank.UpdateActivity()
		end,
		hotkey=iup.K_f,
	}

	TCFT3.GuildBank.ActivityPrevBtn = iup.stationbutton { 
		title="< Previous",
		action = function(self)
			TCFT3.GuildActivity.CurrentPage = TCFT3.GuildActivity.CurrentPage - 1
			if (TCFT3.GuildActivity.CurrentPage<1) then TCFT3.GuildActivity.CurrentPage = 1 end
			TCFT3.GuildBank.UpdateActivity()
		end,
		hotkey=iup.K_p,
	}

	TCFT3.GuildBank.ActivityNextBtn = iup.stationbutton { 
		title="Next >",
		action = function(self)
			TCFT3.GuildActivity.CurrentPage = TCFT3.GuildActivity.CurrentPage + 1
			TCFT3.GuildBank.UpdateActivity()
		end,
		hotkey=iup.K_n,
	}
	
	container = iup.vbox {
		margin="4x4",
		iup.hbox {
			TCFT3.GuildBank.ActivityFirstBtn,
			TCFT3.GuildBank.ActivityPrevBtn,
			TCFT3.GuildBank.ActivityNextBtn,
			iup.fill { size=10 },
			TCFT3.GuildBank.ActivityPage,
		},
		iup.fill { size=10 },
		iup.hbox {
			expand="YES",
			TCFT3.GuildBank.Activity,
		},
	}
	
	container.tabtitle = "Guild Activity"
	container.hotkey = iup.K_l
	function container:OnHelp()
	   TCFT3.ShowHelp("GUILD_ACTIVITY")
	end

	function container:OnActivate(newtab, oldtab)
		if (TCFT3.GuildActivity.FirstUpdate==false) then
			TCFT3.GuildBank.UpdateActivity()
			TCFT3.GuildActivity.FirstUpdate = true
		end
	end

	return container
end

local function createGuildBankLogTab()
	local container

	TCFT3.GuildBank.Log = TCFT3.MatrixList:new()
	TCFT3.GuildBank.Log:addcolumn(TCFT3.MatrixList.column.new("date", "Date", "ARIGHT", { "S:D:date" }, 10))
	TCFT3.GuildBank.Log:addcolumn(TCFT3.MatrixList.column.new("name", "Name", "ALEFT", { "S:A:name" }, 14))
	TCFT3.GuildBank.Log:addcolumn(TCFT3.MatrixList.column.new("withdraw", "Withdraw", "ARIGHT", { "N:D:withdraw" }, 8, { commavalue=true, replace={ ["0"]="" } }))
	TCFT3.GuildBank.Log:addcolumn(TCFT3.MatrixList.column.new("deposit", "Deposit", "ARIGHT", { "N:D:deposit" }, 8, { commavalue=true, replace={ ["0"]="" } }))
	TCFT3.GuildBank.Log:addcolumn(TCFT3.MatrixList.column.new("balance", "Balance", "ARIGHT", { "N:D:balance" }, 9, { commavalue=true, replace={ ["0"]="" } }))
	TCFT3.GuildBank.Log:addcolumn(TCFT3.MatrixList.column.new("desc", "Description", "ALEFT", { "S:A:desc" }, 51))
	TCFT3.GuildBank.Log:init()
	
	TCFT3.GuildBank.LogPage = iup.label { title="Guild Bank Log Page 1", expand="HORIZONTAL", font=Font.H3*HUD_SCALE }

	TCFT3.GuildBank.LogDumpLinenumbers = false
	
	TCFT3.GuildBank.LogFirstBtn = iup.stationbutton { 
		title="<< First",
		action = function(self)
			TCFT3.GuildBankLog.CurrentPage = 1
			TCFT3.GuildBank.UpdateBankLog()
		end,
		hotkey=iup.K_f,
	}

	TCFT3.GuildBank.LogPrevBtn = iup.stationbutton { 
		title="< Previous",
		action = function(self)
			TCFT3.GuildBankLog.CurrentPage = TCFT3.GuildBankLog.CurrentPage - 1
			if (TCFT3.GuildBankLog.CurrentPage<1) then TCFT3.GuildBankLog.CurrentPage = 1 end
			TCFT3.GuildBank.UpdateBankLog()
		end,
		hotkey=iup.K_p,
	}

	TCFT3.GuildBank.LogNextBtn = iup.stationbutton { 
		title="Next >",
		action = function(self)
			TCFT3.GuildBankLog.CurrentPage = TCFT3.GuildBankLog.CurrentPage + 1
			TCFT3.GuildBank.UpdateBankLog()
		end,
		hotkey=iup.K_n,
	}
	
	container = iup.vbox {
		margin="4x4",
		iup.hbox {
			TCFT3.GuildBank.LogFirstBtn,
			TCFT3.GuildBank.LogPrevBtn,
			TCFT3.GuildBank.LogNextBtn,
			iup.fill { size=10 },
			TCFT3.GuildBank.LogPage,
		},
		iup.fill { size=10 },
		iup.hbox {
			expand="YES",
			TCFT3.GuildBank.Log,
		},
		iup.hbox {
			margin="2x15",
			iup.fill {},
			iup.stationtoggle { title="Include line-numbers in log", value="NO", action=function(self, state) if (state==1) then TCFT3.GuildBank.LogDumpLinenumbers=true else TCFT3.GuildBank.LogDumpLinenumbers=false end end },
			iup.fill { size=10 },
			iup.stationbutton { title="Dump to log", action=function() TCFT3.GuildBank.DumpToLog() end }
		}
	}
	
	container.tabtitle = "Guild Bank Log"
	container.hotkey = iup.K_b
	function container:OnHelp()
	   TCFT3.ShowHelp("GUILD_BANKLOG")
	end
	function container:OnActivate(newtab, oldtab)
		if (TCFT3.GuildBankLog.FirstUpdate==false) then
			TCFT3.GuildBank.UpdateBankLog()
			TCFT3.GuildBankLog.FirstUpdate = true
		end
	end

	return container
end


local function createGuildMemberTab()
	local container
	
	TCFT3.Guild.MemberList = TCFT3.MatrixList:new()
	TCFT3.Guild.MemberList:addcolumn(TCFT3.MatrixList.column.new("rank", "Rank", "ALEFT", { "S:A:rank", "S:A:name" }, 15))
	TCFT3.Guild.MemberList:addcolumn(TCFT3.MatrixList.column.new("name", "Name", "ALEFT", { "S:A:name" }, 70))
	TCFT3.Guild.MemberList:addcolumn(TCFT3.MatrixList.column.new("joindate", "Joined", "ARIGHT", { "N:D:joindate" }, 15))
	TCFT3.Guild.MemberList:init()

	TCFT3.Guild.MemberEditButtons = iup.hbox {
		iup.fill {},
		iup.stationbutton {
			title="Create New Member",
			action=TCFT3.Guild.CreateMember,
		},
		iup.fill { size=5 },
		iup.stationbutton {
			title="Edit Member",
			action=TCFT3.Guild.EditMember,
		},
		iup.fill { size=5 },
		iup.stationbutton {
			title="Delete Member",
			action=TCFT3.Guild.DeleteMember,
		},
		visible="NO",
		alignment="ARIGHT",
		margin="0x5",
	}
	
	container = iup.vbox {
		margin="4x4",
		iup.hbox {
			iup.label { title="Guild Members" },
		},
		iup.hbox {
			TCFT3.Guild.MemberList,
		},
		TCFT3.Guild.MemberEditButtons,
		expand="YES",
	}
	
	container.tabtitle = "Guild Members"
	container.hotkey = iup.K_r
	function container:OnHelp()
	   TCFT3.ShowHelp("GUILD_MEMBERS")
	end
	function container:OnActivate(newtab, oldtab)
		if (TCFT3.Guild.MembersFirstUpdate==false) then
			TCFT3.Guild.UpdateGuildMembers()
			TCFT3.Guild.MembersFirstUpdate = true
		end
	end

	return container
end


TCFT3.CreateGuildTab = function()
	local GuildActivityTab = createGuildActivityTab()
	local GuildBankLogTab = createGuildBankLogTab()
	local GuildMemberTab = createGuildMemberTab()
	return TCFT3.subtabs { GuildMemberTab, GuildActivityTab, GuildBankLogTab, 
		OnActivate=function(self, newtab, oldtab)
			if (TCFT3.Guild.MembersFirstUpdate==false) then
					TCFT3.Guild.UpdateGuildMembers()
					TCFT3.Guild.MembersFirstUpdate = true
			end
		end
	}
end


local function createEditDialog()
	local container
	
	TCFT3.EditMemberDialogTitle = iup.label { title="Member", expand="HORIZONTAL", alignment="ACENTER" }
	TCFT3.EditMemberRank = iup.stationsubsublist { dropdown="YES" }
	TCFT3.EditMemberName = iup.text { size="250x" }
	TCFT3.EditMemberJoin = iup.text { size="250x" }
	
	TCFT3.EditMemberRank[1] = nil
	for idx=1, #TCFT3.Guild.MemberRanks+1 do
		TCFT3.EditMemberRank[idx] = TCFT3.Guild.MemberRanks[idx-1]
	end
	
	
	local savebtn = iup.stationbutton {
		title ="Save",
		ALIGNMENT="ACENTER",
		EXPAND="NO",
		action = function(self)
			local member = {}
			member.name = TCFT3.EditMemberName.value
			member.rank = TCFT3.EditMemberRank.value - 1
			member.joindate = TCFT3.EditMemberJoin.value
			member.id = tonumber(TCFT3.EditMemberDialog.saveid) or 0
			if (member.name=="") then
				TCFT3.MessageDialog("Edit Member", "Name missing.")
			else
				TCFT3.Guild.SaveMember(member)
				HideDialog(TCFT3.EditMemberDialog)
			end
		end
	}

	local cancelbtn = iup.stationbutton {
		title ="Cancel",
		ALIGNMENT="ACENTER",
		EXPAND="NO",
		action = function(self)
			HideDialog(TCFT3.EditMemberDialog)
		end
	}

	container = iup.dialog {
		iup.hbox {
			iup.fill {},
			iup.vbox {
				iup.fill {},
				iup.stationhighopacityframe {
					expand="NO",
					-- size="%60x",
					iup.stationhighopacityframebg {
						iup.vbox {
							margin="15x15",
							iup.hbox {
								TCFT3.EditMemberDialogTitle,
							},
							iup.fill { size="15" },
							iup.vbox {
								iup.hbox {
									iup.label { size="100x", title="Rank" },
									TCFT3.EditMemberRank,
								},
								iup.hbox {
									iup.label { size="100x", title="Name" },
									TCFT3.EditMemberName,
								},
								iup.hbox {
									iup.label { size="100x", title="Joined" },
									TCFT3.EditMemberJoin,
								},
							},
							iup.fill { size="15" },
							iup.hbox {
								iup.fill {}, 
								savebtn,
								iup.fill { size=5 },
								cancelbtn,
								iup.fill {}, 
							},
						},
					},
				},
				iup.fill {},
			},
			iup.fill {},
		},
		border="NO",menubox="NO",resize="NO",
		defaultesc=cancelbtn,
		defaultenter=savebtn,
		topmost="YES",
		modal="NO",
		alignment="ACENTER",
		bgcolor="0 0 0 92 *",
		fullscreen="YES",
		show_cb = function(self)
		end
	}
	return container
end

TCFT3.EditMemberDialog = TCFT3.EditMemberDialog or createEditDialog()

















