--[[
ui.inventory
]]

local function createAllInventoryTab()
	local container

	TCFT3.Inventory.LookupList = TCFT3.MatrixList:new()
	TCFT3.Inventory.LookupList:addcolumn(TCFT3.MatrixList.column.new("location", "Location", "ALEFT", { "S:A:location", "S:A:station" }, 25))
	TCFT3.Inventory.LookupList:addcolumn(TCFT3.MatrixList.column.new("station", "Station", "ALEFT", { "S:A:station" }, 25))
	TCFT3.Inventory.LookupList:addcolumn(TCFT3.MatrixList.column.new("itemname", "Item Name", "ALEFT", { "S:A:itemname" }, 40))
	TCFT3.Inventory.LookupList:addcolumn(TCFT3.MatrixList.column.new("quantity", "Quantity", "ARIGHT", { "N:A:quantity" }, 10))

	TCFT3.Trading.LookupItemType = iup.stationsublist { dropdown='yes', size='%20x', expand='NO', visible_items=15 }
	TCFT3.Inventory.TotalItems = iup.label { title="0", wordwrap="NO", expand="HORIZONTAL" }
	TCFT3.Inventory.LookupList:init()
	
	local RefreshButton = iup.stationbutton { 
		title="Refresh",
		action = function(self)
			TCFT3.Inventory.RefreshList()
		end,
		hotkey=iup.K_r,
	}
	
	container = iup.vbox {
		margin="4x4",
		iup.hbox {
			iup.label { title="Inventory List", font=Font.H3*HUD_SCALE }, iup.fill { size=25 }, 
			iup.label { title="Display item " },
			TCFT3.Trading.LookupItemType,
			iup.fill { size=15 },
			RefreshButton, iup.fill {},
		},
		iup.fill { size=10 },
		iup.hbox {
			expand="YES",
			TCFT3.Inventory.LookupList,
		},
		iup.fill { size=10 },
		iup.hbox {
			alignment="ARIGHT",
			expand="YES",
			margin="5x0",
			iup.label { title="Total number of items ", expand="HORIZONTAL", alignment="ARIGHT" },
			TCFT3.Inventory.TotalItems,
		},
	}
	
	container.tabtitle = "Inventory List"
	container.hotkey = iup.K_l
	function container:OnHelp()
	   TCFT3.ShowHelp("INVENTORY_ALL")
	end

	return container
end

TCFT3.CreateInventoryTab = function()
	local AllInventoryTab = createAllInventoryTab()
	
	return TCFT3.subtabs { AllInventoryTab,
		OnActivate = function(self, newtab, oldtab)
			TCFT3.Inventory.UpdateItemlist()
		end
	}
end
