--[[
TCFT3
(c) By Plozi
Version 1.0.0

** Changelog

]]


TCFT3.LastSeen.CreateMainWindow = function()

	if (TCFT3.LastSeen.List==nil) then
		TCFT3.LastSeen.List = TCFT3.MatrixList:new()
		TCFT3.LastSeen.List:addcolumn(TCFT3.MatrixList.column.new("guildtag", "Guild", "ALEFT", { "S:A:guildtag", "S:A:name" }, 10))
		TCFT3.LastSeen.List:addcolumn(TCFT3.MatrixList.column.new("name", "Player Name", "ALEFT", { "S:A:name", "S:D:date" }, 27))
		TCFT3.LastSeen.List:addcolumn(TCFT3.MatrixList.column.new("date", "Last Seen", "ARIGHT", { "S:D:date" }, 15))
		TCFT3.LastSeen.List:addcolumn(TCFT3.MatrixList.column.new("location", "Location", "ALEFT", { "S:A:location", "S:D:date", "S:A:name" }, 22))
		TCFT3.LastSeen.List:addcolumn(TCFT3.MatrixList.column.new("shipname", "Ship", "ALEFT", { "S:A:shipname", "S:D:date" }, 26))
		TCFT3.LastSeen.List:set_sortcol(2)
		TCFT3.LastSeen.List:init()
	end
	
	TCFT3.LastSeen.Type = TCFT3.LastSeen.Type or iup.stationsublist { "Current Sector", "Player Name", "Guild", "Display ALL"; dropdown="YES",
		action=function(self, text, idx, state)
			if (state==1) then
				local num = tonumber(TCFT3.LastSeen.Type.value)
				if (num==1) or (num==4) then
					TCFT3.LastSeen.InputData.active="NO"
				else
					TCFT3.LastSeen.InputData.active="YES"
				end
			end
		end,
	}
	TCFT3.LastSeen.InputData = TCFT3.LastSeen.InputData or iup.text { value="", size="%25x", active="NO",
		action = function(self, ch, str)
			if (ch==13) then
				TCFT3.LastSeen.Update()
			end
		end,
	} 
	TCFT3.LastSeen.closeBtn = TCFT3.LastSeen.closeBtn or iup.stationbutton {
		title = "Close",
		ALIGNMENT="ACENTER",
		EXPAND="NO",
		action = function(self)
			HideDialog(TCFT3.LastSeen.MainWindow)
		end
	}

	local focusgrabber = iup.canvas {size="1x1", border="NO", expand="NO" }
	TCFT3.LastSeen.MainWindow = TCFT3.LastSeen.MainWindow or iup.dialog {
		iup.stationhighopacityframe {
			iup.vbox {
				margin="5x5",
				iup.hbox {
					iup.fill{}, iup.label { title="TCFT3 Last Seen List", font=Font.H3*HUD_SCALE }, iup.fill{},
				},
				iup.hbox {
					margin="10x10",
					iup.label { title="List By: " },
					TCFT3.LastSeen.Type,
					iup.fill { size=3 },
					TCFT3.LastSeen.InputData,
					iup.fill { size=3 },
					iup.stationbutton {
						title="Update",
						hotkey=iup.K_u,
						action=function()
							TCFT3.LastSeen.Update()
						end,
					},
				},
				iup.hbox {
					TCFT3.LastSeen.List,
				},
				focusgrabber, 
				iup.hbox {
					iup.vbox {
						iup.fill { size="10"},
						iup.hbox {
							iup.fill {}, TCFT3.LastSeen.closeBtn, iup.fill {},
						},
					},					
				},
			},
		},
		size="%80x%80",
		bgcolor="40 40 40 150 *",
		border="NO",menubox="NO",resize="NO",
		defaultesc=TCFT3.LastSeen.closeBtn,
		defaultenter=TCFT3.LastSeen.refreshBtn,
		defaultfocus=focusgrabber,
		topmost="YES",
		modal="YES",
		alignment="ACENTER",
		bgcolor="40 40 40 128 *",
		show_cb = function(self)
			TCFT3.LastSeen.List:map()
			if ((tonumber(TCFT3.LastSeen.Type.value) or 0)<1) then TCFT3.LastSeen.Type.value = 1 end
		end,
		hide_cb = function()
		end,
		map_cb = function()
			
		end,
	}
end

