--[[
TCFT3
(c) By Plozi
Version 1.1.0

** Changelog
  v.1.1.0 ScionSpy
  ** Commented out "Scanner" and "Auto Jet" buttons (Line 568-585)
  ** Added a "CapshipSecondaryInfo" parent to make 'TCFT3' button clickable whilst in capship dock. (Line 637)
  ** Added a few "iup.GetParent()" to make the 'TCFT3' button not "Merged" with player info.
]]


-- TCFT Main tab - communication etc
local function createTcftMainTab()
	local container
	TCFT3.txt_status = TCFT3.txt_status or iup.multiline { value = "", expand = 'YES', readonly = 'YES', bgcolor="0 0 0 *", border="NO" }
	TCFT3.txt_tcftchatline = iup.multiline { value="", expand="HORIZONTAL", size="x"..Font.Default, SCROLLBAR="NO" }
	TCFT3.chatlabel = iup.label { title = TCFT3.colors.GREEN2 .. "TCFT3: " }
	TCFT3.rdo_chattype = {}
	TCFT3.rdo_chattype[1] = iup.stationradio { title="TCFT3", expand="NO", action=function(self,state) if (state==1) then TCFT3.SetChatType(1) end end, gap="5" }
	TCFT3.rdo_chattype[2] = iup.stationradio { title="Guild", expand="NO", action=function(self,state) if (state==1) then TCFT3.SetChatType(2) end end, gap="5" }
	TCFT3.rdo_chattype.gap = 5
	TCFT3.ChatTypeRadio = iup.radio { iup.hbox(TCFT3.rdo_chattype), value=TCFT3.rdo_chattype[1] }

	function TCFT3.txt_tcftchatline:action(key, str)
		if (key==9) then
			self.value = tabcomplete(TCFT3.txt_tcftchatline.value, TCFT3.txt_tcftchatline.caret)
			return iup.IGNORE
		end
		-- TCFT3.AddStatus(key)
		if (key==7) then -- Guild chat
			TCFT3.SetChatType(2)
			return iup.IGNORE
		elseif (key==20) then -- tcft chat
			TCFT3.SetChatType(1)
			return iup.IGNORE
		end
		if (key==16) then -- CTRL-P reply to last private msg
			if (TCFT3.txt_tcftchatline.value == '?' and TCFT3.LastPrivMsgUser ~= "") then
				TCFT3.txt_tcftchatline.value = "/msg \"" .. TCFT3.LastPrivMsgUser .. "\" "
			else
				return iup.IGNORE
			end
		end
		if (key==13) then
			TCFT3.TCFTChat()
		end
	end

	container = iup.vbox {
		bgcolor="200 200 200 *",
		iup.hbox {
			margin="5x5",
			TCFT3.txt_status,
		},
		iup.hbox {
			margin="3x2",
			iup.label { title="Chat to " }, TCFT3.ChatTypeRadio,
		},
		iup.hbox {
			margin = "2x2",
			TCFT3.chatlabel,
			TCFT3.txt_tcftchatline,
		},
		OnActivate = function()
			-- iup.SetFocus(TCFT3.txt_tcftchatline)
		end,
	}
	container.tabtitle = "Comm"
	container.hotkey = iup.K_c
	function container:OnHelp()
	   TCFT3.ShowHelp("MAIN_COMM")
	end
	return container
end


-- Create the main TCFT tab
local function createTCFTTab()
	local tcftMainTab = createTcftMainTab()
    local curtab = tcftMainTab
	return TCFT3.subtabs { tcftMainTab,
		OnActivate = function(self, newtab, oldtab)
			TCFT3.MainTabs:SetTabTextColor(2, "255 255 255")
		end
	}
end


TCFT3.TCFTTab = createTCFTTab()
TCFT3.TCFTTab.tabtitle = "TCFT"
TCFT3.TCFTTab.hotkey = iup.K_c

-- TCFT3.TCFTTab:GetTabButton(1).size= "%10x"


TCFT3.TradeTab = TCFT3.CreateTradeTab()
TCFT3.TradeTab.tabtitle = "Trading"
TCFT3.TradeTab.hotkey=iup.K_t
-- TCFT3.TradeTab:GetTabButton(1).size= "%10x"

TCFT3.MiningTab = TCFT3.CreateMiningTab()
TCFT3.MiningTab.tabtitle = "Mining"
TCFT3.MiningTab.hotkey=iup.K_m
-- TCFT3.MiningTab:GetTabButton(1).size= "%10x"

TCFT3.SettingsTab = TCFT3.CreateSettingsTab()
TCFT3.SettingsTab.tabtitle = "Settings"
TCFT3.SettingsTab.hotkey = iup.K_e
-- TCFT3.SettingsTab:GetTabButton(1).size= "%10x"

TCFT3.InventoryTab = TCFT3.CreateInventoryTab()
TCFT3.InventoryTab.tabtitle = "Inventory"
TCFT3.InventoryTab.hotkey = iup.K_i

TCFT3.GuildTab = TCFT3.CreateGuildTab()
TCFT3.GuildTab.tabtitle = "Guild"
TCFT3.GuildTab.hotkey = iup.K_g

TCFT3.PlayersTab = TCFT3.CreatePlayersTab()
TCFT3.PlayersTab.tabtitle = "Last Seen"
TCFT3.PlayersTab.hotkey = iup.K_a

TCFT3.MainTabs = iup.pda_root_tabs {
	TCFT3.TCFTTab,
	TCFT3.TradeTab,
	TCFT3.MiningTab,
	TCFT3.InventoryTab,
	TCFT3.GuildTab,
	TCFT3.PlayersTab,
	TCFT3.SettingsTab,
	tabchange_cb = function(self, newtab, oldtab)
		if (oldtab.OnDeactivate) then
			oldtab:OnDeactivate(newtab, oldtab)
		end
		if (newtab.OnActivate) then
			newtab:OnActivate(newtab, oldtab)
		end
		TCFT3.CurMainTab = newtab
	end,
}


TCFT3.statusline = TCFT3.statusline or iup.label { title = TCFT3.colors.RED .. "Not connnected.", expand="HORIZONTAL" }

TCFT3.connectButton = TCFT3.connectButton or iup.stationbutton {
	title=" Connect ",
	action=function()
		TCFT3.Connection.CheckConnection()
	end,
	size = tostring(Font.Default*8).."x",
}

TCFT3.loadSectorButton = TCFT3.loadSectorButton or iup.stationbutton {
	title=" Load Sector ",
	action=function()
		TCFT3.Mining.LoadSector()
	end,
	size = tostring(Font.Default*8).."x",
}

TCFT3.reloadinterfacebtn = TCFT3.reloadinterfacebtn or iup.stationbutton {
	title=" Reload Interface ",
	action=function()
		ReloadInterface()
	end,
	size = tostring(Font.Default*8).."x",
}


-- Create interface and display main page
TCFT3.DisplayTCFT3 = function()

	local tcCancelBtn = iup.stationbutton {
		title="Close TCFT3",
		action=function()
			HideDialog(TCFT3.MainWindow)
		end,
		size = tostring(Font.Default*8).."x",
	}

	TCFT3.bottom = TCFT3.bottom or iup.vbox {
		iup.hbox {
			TCFT3.statusline,
			iup.fill {},
			TCFT3.reloadinterfacebtn,
			iup.fill { size="%2" },
			TCFT3.loadSectorButton,
			iup.fill { size="%2" },
			TCFT3.connectButton,
			tcCancelBtn,
		},
	}

	TCFT3.MainWindow = TCFT3.MainWindow or iup.dialog {
		iup.stationhighopacityframe {
			--iup.stationhighopacityframebg {
				iup.vbox {
                    -- iup.label { title="T C F T  2", expand="HORIZONTAL", alignment="ACENTER" },
                   iup.zbox {
                        expand="YES",
                        all="YES",
                        iup.hbox {
                            alignment="NE",
                            iup.fill{}, iup.label { title = "", image="plugins/TCFT3/images/TCFT3_logo.png" },
                        },
                        iup.vbox {
                            alignment="ACENTER",
                            iup.fill { size=3 }, -- 15 to 3 -- tokkano
                            	iup.label { title="T C F T  2 ", expand="HORIZONTAL", alignment="ARIGHT" },
                        },
                        iup.vbox {
                            iup.fill { size="1" }, -- 35 to 1 -- tokkana
        				    TCFT3.MainTabs,
        				},
                    },
					iup.hbox {
						margin="3x1",
						expand="YES",
						TCFT3.bottom,
					},
				},
			--},
		},
		topmost="YES",
		resize="NO",
		fullscreen="YES",
		expand="NO",
		modal="YES",
		border="NO",
		alignment="ATOP",
		defaultesc=tcCancelBtn,
		show_cb = function(self)
			if (GetCurrentStationType()~=1 and PlayerInStation()) then
				HideDialog(StationDialog)
			end
			-- Update systems dropdown
			TCFT3.Mining.MineralSearch.SearchSystem[1] = "Current sector"
			for i=1,#TCFT3.SystemNames do
				TCFT3.Trading.LookupSystem[i+1] = TCFT3.SystemNames[i]
				TCFT3.Mining.MiningMap.LookupSystem[i] = TCFT3.SystemNames[i]
				TCFT3.Mining.MineralSearch.SearchSystem[i+1] = TCFT3.SystemNames[i]
			end
			ProcessEvent("TCFT3_SHOW")
		end,
		hide_cb = function(self)
			if (GetCurrentStationType()~=1 and PlayerInStation()) then
				ShowDialog(StationDialog)
			end
			ProcessEvent("TCFT3_HIDE")
		end,
		map_cb = function(self)
			ProcessEvent("TCFT3_MAIN_MAP")
		end,
		bgcolor="40 40 40 192 *"
	}
	PopupDialog(TCFT3.MainWindow, iup.CENTER, iup.CENTER)
end


-- Configmdialog
TCFT3.ConfirmDialog = function(title, message, okbtn, okbtnfunc, cancelbtn, cancelbtnfunc)
	TCFT3.ConfirmDlgCancelBtn = TCFT3.ConfirmDlgCancelBtn or iup.stationbutton {
		title = cancelbtn or "Cancel",
		ALIGNMENT="ACENTER",
		EXPAND="NO",
	}
	function TCFT3.ConfirmDlgCancelBtn:action(self)
		HideDialog(TCFT3.ConfirmDlg)
		if (cancelbtnfunc ~= nil) then cancelbtnfunc(self) end
	end


	 TCFT3.ConfirmDlgOkBtn = TCFT3.ConfirmDlgOkBtn or iup.stationbutton {
		title = okbtn or "OK",
		ALIGNMENT="ACENTER",
		EXPAND="NO",
	}
	function TCFT3.ConfirmDlgOkBtn:action(self)
		HideDialog(TCFT3.ConfirmDlg)
		if (okbtnfunc ~= nil) then okbtnfunc(self) end
	end


	TCFT3.ConfirmDlgTitle = TCFT3.ConfirmDlgTitle or iup.label { title="", alignment="ACENTER", expand="YES", font=Font.H2*HUD_SCALE }
	TCFT3.ConfirmDlgMsg = TCFT3.ConfirmDlgMsg or iup.label { title="", alignment="ALEFT", expand="YES", margin="5x15" }

	TCFT3.ConfirmDlg = TCFT3.ConfirmDlg or iup.dialog{
		iup.hbox {
			iup.fill {},
			iup.vbox {
				iup.fill {},
				iup.stationhighopacityframe{
					expand="NO",
					iup.stationhighopacityframebg{
						iup.vbox { margin="15x15",
							iup.hbox {
								TCFT3.ConfirmDlgTitle,
							},
							iup.fill { size="15" },
							iup.hbox {
								TCFT3.ConfirmDlgMsg,
							},
							iup.fill { size="15" },
							iup.hbox {
								iup.fill {},
								TCFT3.ConfirmDlgOkBtn,
								iup.fill { size="3" },
								TCFT3.ConfirmDlgCancelBtn,
								iup.fill {},
							},
						},
					},
				},
				iup.fill {},
			},
			iup.fill {},
		},
		border="NO",menubox="NO",resize="NO",
		defaultesc=TCFT3.ConfirmDlgCancelBtn,
		defaultenter=TCFT3.ConfirmDlgOkBtn,
		topmost="YES",
		modal="YES",
		bgcolor="0 0 0 92 *",
		fullscreen="YES",
	}
	TCFT3.ConfirmDlgCancelBtn.title = cancelbtn
	TCFT3.ConfirmDlgOkBtn.title = okbtn
	TCFT3.ConfirmDlgTitle.title = title
	TCFT3.ConfirmDlgMsg.title = message
	PopupDialog(TCFT3.ConfirmDlg,iup.CENTER, iup.CENTER)
end

-- Messagemdialog
TCFT3.MessageDialog = function(title, message)
	local okbtn = iup.stationbutton {
		title ="OK",
		ALIGNMENT="ACENTER",
		EXPAND="NO",
		action = function(self)
			HideDialog(TCFT3.MessageDlg)
		end
	}

	TCFT3.MessageDlgTitle = TCFT3.MessageDlgTitle or iup.label { title="", alignment="ACENTER", expand="YES", font=Font.H2*HUD_SCALE }
	TCFT3.MessageDlgMsg = TCFT3.MessageDlgMsg or iup.label { title="", alignment="ALEFT", expand="YES", margin="5x15" }

	TCFT3.MessageDlg = TCFT3.MessageDlg or iup.dialog{
		iup.hbox {
			iup.fill {},
			iup.vbox {
				iup.fill {},
				iup.stationhighopacityframe{
					expand="NO",
					iup.stationhighopacityframebg{
						iup.vbox { margin="15x15",
							iup.hbox {
								TCFT3.MessageDlgTitle,
							},
							iup.fill { size="15" },
							iup.hbox {
								TCFT3.MessageDlgMsg,
							},
							iup.fill { size="15" },
							iup.hbox {
								iup.fill {},
								okbtn,
								iup.fill {},
							},
						},
					},
				},
				iup.fill {},
			},
			iup.fill {},
		},
		border="NO",menubox="NO",resize="NO",
		defaultesc=okbtn,
		topmost="YES",
		modal="YES",
		alignment="ACENTER",
		bgcolor="0 0 0 92 *",
		fullscreen="YES",
	}
	TCFT3.MessageDlgTitle.title = title
	TCFT3.MessageDlgMsg.title = message
	PopupDialog(TCFT3.MessageDlg,iup.CENTER, iup.CENTER)
end

-- Errordialog
TCFT3.ErrorDialog = function(title, message)
	local okbtn = iup.stationbutton {
		title ="OK",
		ALIGNMENT="ACENTER",
		EXPAND="NO",
		action = function(self)
			HideDialog(TCFT3.ErrorDlg)
		end
	}

	TCFT3.ErrorDlgTitle = TCFT3.ErrorDlgTitle or iup.label { title="", alignment="ACENTER", expand="YES", font=Font.H2*HUD_SCALE }
	TCFT3.ErrorDlgMsg = TCFT3.ErrorDlgMsg or iup.label { title="", alignment="ALEFT", expand="YES", margin="5x15" }

	TCFT3.ErrorDlg = TCFT3.ErrorDlg or iup.dialog{
		iup.hbox {
			iup.fill {},
			iup.vbox {
				iup.fill {},
				iup.stationhighopacityframe{
					expand="NO",
					iup.stationhighopacityframebg{
						iup.vbox { margin="15x15",
							iup.hbox {
								TCFT3.ErrorDlgTitle,
							},
							iup.fill { size="15" },
							iup.hbox {
								TCFT3.ErrorDlgMsg,
							},
							iup.fill { size="15" },
							iup.hbox {
								iup.fill {},
								okbtn,
								iup.fill {},
							},
						},
					},
				},
				iup.fill {},
			},
			iup.fill {},
		},
		border="NO",menubox="NO",resize="NO",
		defaultesc=okbtn,
		topmost="YES",
		modal="YES",
		alignment="ACENTER",
		bgcolor="0 0 0 92 *",
		fullscreen="YES",
	}
	TCFT3.ErrorDlgTitle.title = TCFT3.colors.RED .. title
	TCFT3.ErrorDlgMsg.title = message
	PopupDialog(TCFT3.ErrorDlg, iup.CENTER, iup.CENTER)
end


TCFT3.ProgressDialog = function(header, message, cancelfunc, min, max)
	TCFT3.ProgressDialogCancel = TCFT3.ProgressDialogCancel or iup.stationbutton {
		title ="CANCEL",
		ALIGNMENT="ACENTER",
		EXPAND="NO",
		action = function(self)
			HideDialog(TCFT3.ProgressDlg)
			if (cancelfunc) then
				cancelfunc()
			end
		end
	}

	TCFT3.ProgressDialogPercent = TCFT3.ProgressDialogPercent or iup.label { title="0%", alignment="ACENTER", expand="NO", size=Font.Default * 4 }
	TCFT3.ProgressDialogHeader = TCFT3.ProgressDialogHeader or iup.label { title="", font=Font.H3*HUD_SCALE }
	TCFT3.ProgressDialogMsg = TCFT3.ProgressDialogMsg or iup.label { title="" }
	TCFT3.ProgressDialogProgressBar = TCFT3.ProgressDialogProgressBar or iup.stationprogressbar {
		LOWERCOLOR="64 255 64 128 *",
		--MIDDLEABOVECOLOR="0 255 0",
		--MIDDLEBELOWCOLOR="0 0 255",
		UPPERCOLOR="128 128 128 128 *",
		MINVALUE=(min or 0),
		MAXVALUE=(max or 100),
		type="HORIZONTAL",
		-- mode="TRINARY",
		expand="HORIZONTAL",
		--size="180x12",
		size="x12",
	}

	TCFT3.ProgressDlg = TCFT3.ProgressDlg or iup.dialog {
		iup.vbox {
			iup.fill {},
			iup.hbox {
				iup.fill {},
				iup.stationhighopacityframe {
					iup.stationhighopacityframebg {
						expand="NO",
						iup.vbox {
							margin="30x20",
							alignment="ACENTER",
							iup.hbox {
								TCFT3.ProgressDialogHeader,
							},
							iup.fill { size=20 },
							iup.hbox {
								iup.fill {},
								iup.zbox {
									alignment="ACENTER",
									TCFT3.ProgressDialogProgressBar,
									TCFT3.ProgressDialogPercent,
									all="YES",
								},
								iup.fill {},
							},
							iup.fill { size=15 },
							iup.hbox {
								TCFT3.ProgressDialogMsg,
							},
							iup.fill { size=15 },
							iup.hbox {
								TCFT3.ProgressDialogCancel,
							},
						},
					},
				},
				iup.fill {},
			},
			iup.fill {},
		},
		bgcolor="0 0 0 128 *",
		border="NO",menubox="NO",resize="NO",
		defaultesc=TCFT3.ProgressDialogCancel,
		topmost="YES",
		modal="NO",
		alignment="ACENTER",
		fullscreen="YES",
	}
	TCFT3.ProgressDialogProgressBar.value=0
	TCFT3.ProgressDialogPercent.title = "0%"
	TCFT3.ProgressDialogHeader.title = header
	TCFT3.ProgressDialogMsg.title = message
	ShowDialog(TCFT3.ProgressDlg, iup.CENTER, iup.CENTER)
end

TCFT3.ProgressDialogUpdate = function(event, value)
	value = (tonumber(value) or 0)
	TCFT3.ProgressDialogProgressBar.value = value>100 and 100 or value
	TCFT3.ProgressDialogPercent.title=string.format("%d%%", (value>100 and "100" or value))
end

TCFT3.ProgressDialogHide = function()
	HideDialog(TCFT3.ProgressDlg)
	TCFT3.ProgressDialogProgressBar.value = "0%"
end


TCFT3.InitButtons = function()
	-- PDA
--local parent = iup.GetParent(iup.GetParent(iup.GetParent(iup.GetParent(PDASecondaryInfo))))
local parent = iup.GetParent(iup.GetParent(iup.GetParent(iup.GetParent(iup.GetParent(PDASecondaryInfo)))))--'TCFT3' button will not appear "merged" with the player information.
PDASecondaryInfo.SIZE="208x100"
PDASecondaryInfo.ALIGNMENT="ACENTER"
if (parent~=nil) then
		local chlds = {}
		local chld = iup.GetNextChild(parent)
		repeat
			if (chld~=nil) then
				table.insert(chlds, chld)
				chld = iup.GetNextChild(parent, chld)
			end
		until chld==nil
		TCFT3.PDASecInfo = iup.pdasubframe_nomargin{
			iup.hbox{
				iup.vbox{
					iup.stationbutton {
						title = "TCFT3",
						EXPAND="HORIZONTAL",
						action = function(self)
							TCFT3.DisplayTCFT3()
						end,
						hotkey = iup.K_2
					},
					--[[  Commented our by request ~Spy
					iup.fill { size="2" },
					iup.stationbutton {
						title = "Toggle Scanner",
						EXPAND="HORIZONTAL",
						action = function(self)
							TCFT3.Mining.Scanner.Toggle()
						end,
					},
					iup.fill { size="2" },
					iup.stationbutton {
						title = "Toggle AutoEject",
						EXPAND="HORIZONTAL",
						action = function(self)
							TCFT3.Mining.AutoEjectToggle()
						end,
					},
					]]
					margin="5x5",
				},
				expand="NO",
				size="%13x",
			},
			expand="NO",
			secinfoparent=parent,
			secinfochilds=chlds,
			displayed=false,
		}
	end

	-- Station
	--local parent = iup.GetParent(iup.GetParent(iup.GetParent(iup.GetParent(StationSecondaryInfo))))
	local parent = iup.GetParent(iup.GetParent(iup.GetParent(iup.GetParent(iup.GetParent(StationSecondaryInfo)))))--'TCFT3' button will not appear "merged" with the player information.
	if (parent~=nil) then
		local chlds = {}
		local chld = iup.GetNextChild(parent)
		repeat
			if (chld~=nil) then
				table.insert(chlds, chld)
				chld = iup.GetNextChild(parent, chld)
			end
		until chld==nil
		TCFT3.StationSecInfo = iup.pdasubframe_nomargin{
			iup.hbox{
				iup.vbox{
					iup.stationbutton {
						title = "TCFT3",
						EXPAND="HORIZONTAL",
						action = function(self)
							TCFT3.DisplayTCFT3()
						end,
						hotkey = iup.K_2
					},
					margin="5x5",
				},
				expand="NO",
				size="%13x",
			},
			expand="NO",
			secinfoparent=parent,
			secinfochilds=chlds,
			displayed=false,
		}
	end

	-- CapShip
	--local parent = iup.GetParent(iup.GetParent(iup.GetParent(iup.GetParent(CapShipSecondaryInfo))))
	local parent = iup.GetParent(iup.GetParent(iup.GetParent(iup.GetParent(iup.GetParent(CapShipSecondaryInfo)))))--'TCFT3' button will not appear "merged" with the player information.
	if (parent~=nil) then
		local chlds = {}
		local chld = iup.GetNextChild(parent)
		repeat
			if (chld~=nil) then
				table.insert(chlds, chld)
				chld = iup.GetNextChild(parent, chld)
			end
		until chld==nil
		TCFT3.CapshipSecInfo = iup.pdasubframe_nomargin{
			iup.hbox{
				iup.vbox{
					iup.stationbutton {
						title = "TCFT3",
						EXPAND="HORIZONTAL",
						action = function(self)
							TCFT3.DisplayTCFT3()
						end,
						hotkey = iup.K_2
					},
					margin="5x5",
				},
				expand="NO",
				size="%13x",
			},
			expand="NO",
			secinfoparent=parent,
			secinfochilds=chlds,
			displayed=false,
		}
	end
end


TCFT3.AddButtons = function(secinfo)
	if (secinfo==nil) then return end
	if (secinfo.displayed) then return end
	for idx, chld in ipairs(secinfo.secinfochilds) do
		iup.Detach(chld)
	end
	iup.Append(secinfo.secinfoparent, secinfo)
	for idx, chld in ipairs(secinfo.secinfochilds) do
		iup.Append(secinfo.secinfoparent, chld)
	end
	secinfo.displayed=true
	iup.Refresh(secinfo.secinfoparent)
end

TCFT3.RemoveButtons = function(secinfo)
	if (secinfo==nil) then return end
	if (not secinfo.displayed) then return end
	iup.Detach(secinfo)
	secinfo.displayed=false
	iup.Refresh(secinfo.secinfoparent)
end


RegisterEvent(TCFT3.ProgressDialogUpdate, "TCFT3_UPDATEPROGRESSBAR")
RegisterEvent(TCFT3.ProgressDialogHide, "TCFT3_PROGRESSBARDONE")
